/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let ButtonVisualModelExport = /*@__PURE__*/ (() => {
    class ButtonVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.q = 0;
            this.o = 0;
            this.p = 0;
            this.c = null;
            this.n = null;
            this.k = null;
            this.a = null;
            this.ab = 0;
            this.z = 0;
            this.aa = 0;
            this.l = null;
            this.ao = null;
            this.b = null;
            this.d = null;
            this.e = null;
            this.f = null;
            this.y = 0;
            this.r = 0;
            this.m = null;
            this.j = null;
            this.g = null;
            this.h = null;
            this.i = null;
            this.w = 0;
            this.al = null;
            this.am = null;
            this.an = null;
            this.x = 0;
            this.aj = null;
            this.ak = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ad = null;
            this.ac = null;
            this.ah = null;
            this.u = false;
            this.s = false;
            this.v = false;
            this.t = false;
        }
        ai() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("density : " + enumGetBox(ControlDisplayDensity_$type, this.q) + ", ");
            a.l("baseTheme : " + enumGetBox(BaseControlTheme_$type, this.o) + ", ");
            a.l("actualDensity : " + enumGetBox(ControlDisplayDensity_$type, this.p) + ", ");
            a.l("actualBorderColor : " + this.c.serialize() + ", ");
            a.l("actualUmbraShadowColor : " + this.n.serialize() + ", ");
            a.l("actualPenumbraShadowColor : " + this.k.serialize() + ", ");
            a.l("actualAmbientShadowColor : " + this.a.serialize() + ", ");
            a.l("actualRestingElevation : " + this.ab + ", ");
            a.l("actualFocusElevation : " + this.z + ", ");
            a.l("actualHoverElevation : " + this.aa + ", ");
            if (this.l != null) {
                a.l("actualRippleColor : " + this.l.serialize() + ", ");
            }
            a.l("actualCornerRadius : " + this.ao + ", ");
            a.l("actualBackgroundColor : " + this.b.serialize() + ", ");
            a.l("actualDisabledBackgroundColor : " + this.d.serialize() + ", ");
            a.l("actualDisabledBorderColor : " + this.e.serialize() + ", ");
            a.l("actualDisabledTextColor : " + this.f.serialize() + ", ");
            a.l("actualDisabledElevation : " + this.y + ", ");
            a.l("actualElevationMode : " + enumGetBox(ElevationMode_$type, this.r) + ", ");
            a.l("actualTextColor : " + this.m.serialize() + ", ");
            a.l("actualHoverTextColor : " + this.j.serialize() + ", ");
            a.l("actualFocusBackgroundColor : " + this.g.serialize() + ", ");
            a.l("actualFocusTextColor : " + this.h.serialize() + ", ");
            a.l("actualHoverBackgroundColor : " + this.i.serialize() + ", ");
            a.l("actualBorderWidth : " + this.w + ", ");
            if (!stringIsNullOrEmpty(this.al)) {
                a.l("textStyleFontStyle : \"" + this.al + "\", ");
            }
            if (!stringIsNullOrEmpty(this.am)) {
                a.l("textStyleFontVariant : \"" + this.am + "\", ");
            }
            if (!stringIsNullOrEmpty(this.an)) {
                a.l("textStyleFontWeight : \"" + this.an + "\", ");
            }
            if (!stringIsNullOrEmpty(this.aj)) {
                a.l("textStyleFontFamily : \"" + this.aj + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ak)) {
                a.l("textStyleFontStretch : \"" + this.ak + "\", ");
            }
            if (!isNaN_(this.x)) {
                a.l("textStyleFontSize : " + this.x + ", ");
            }
            a.l("display : " + this.ae + ", ");
            a.l("flexDirection : " + this.af + ", ");
            a.l("flexGrow : " + this.ag + ", ");
            a.l("alignItems : " + this.ad + ", ");
            a.l("value : " + this.ac + ", ");
            a.l("name : " + this.ah + ", ");
            a.l("isFocused : " + this.u + ", ");
            a.l("actualDisableRipple : " + this.s + ", ");
            a.l("isHover : " + this.v + ", ");
            a.l("isDisabled : " + this.t + ", ");
            a.l("}");
            return a.toString();
        }
    }
    ButtonVisualModelExport.$t = /*@__PURE__*/ markType(ButtonVisualModelExport, 'ButtonVisualModelExport');
    return ButtonVisualModelExport;
})();
//# sourceMappingURL=ButtonVisualModelExport.js.map
