/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, toNullable, Date_$type, enumGetBox } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { DayInfo } from "./DayInfo";
import { Button } from "./Button";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { Icon } from "./Icon";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { nullableNotEquals, unwrapNullable } from "igniteui-react-core";
import { dateNow, dateAddYears, dateFromValues, dateGetMonth, dateAddDays, dateAddMonths } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let CalendarView = /*@__PURE__*/ (() => {
    class CalendarView extends Base {
        constructor() {
            super();
            this.g = null;
            this.i = null;
            this.j = null;
            this.c = new List$1(DomWrapper_$type, 0);
            this.b = new List$1(DomWrapper_$type, 0);
            this.d = new List$1(DomWrapper_$type, 0);
            this.e = new List$1(DomWrapper_$type, 0);
            this.h = null;
            this.l = null;
            this.a = null;
            this.f = null;
            this.l = "day";
            this.h = null;
        }
        w() {
        }
        v(a) {
            if (a == null) {
                this.f = null;
                return;
            }
            this.f = a;
            this.f.rootWrapper.setStyleProperty("background-color", "rgb(255, 255, 255)");
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.n();
            this.af();
            this.ag();
            this.ae();
            let d = this.f.rootWrapper;
            d.listen("keydown", runOn(this, this.m));
        }
        n() {
            if (this.f != null) {
                this.g = this.f.createElement("div");
                this.g.setStyleProperty("height", "100%");
                this.f.append(this.g);
                for (let a = 0; a < 42; a++) {
                    let b = this.f.createElement("div");
                    this.b.add(b);
                }
                this.a.ar(this.f, this.g, this.b);
                this.i = this.f.createElement("div");
                this.i.setStyleProperty("height", "100%");
                this.f.append(this.i);
                for (let c = 0; c < 12; c++) {
                    let d = this.f.createElement("div");
                    this.d.add(d);
                }
                this.a.at(this.f, this.i, this.d);
                for (let e = 0; e < 12; e++) {
                    let f = this.i.getChildAt(e);
                    f.listen("click", runOn(this, this.q));
                }
                this.i.hide();
                this.j = this.f.createElement("div");
                this.j.setStyleProperty("height", "100%");
                this.f.append(this.j);
                for (let g = 0; g < 7; g++) {
                    let h = this.f.createElement("div");
                    this.e.add(h);
                }
                this.a.au(this.f, this.j, this.e);
                for (let i = 0; i < 7; i++) {
                    let j = this.j.getChildAt(i);
                    j.listen("click", runOn(this, this.ai));
                }
                this.j.listen("wheel", runOn(this, this.aj));
                this.j.hide();
            }
        }
        af() {
            if (this.f != null) {
                let a = this.g.getChildAt(0);
                for (let b = 0; b < 4; b++) {
                    let c = this.f.createElement("div");
                    this.c.add(c);
                }
                this.a.bc(this.f, a, this.c);
                let d = a.getChildAt(0);
                let e = a.getChildAt(3);
                d.listen("click", runOn(this, this.x));
                e.listen("click", runOn(this, this.s));
                let f = a.getChildAt(1);
                let g = a.getChildAt(2);
                f.listen("click", runOn(this, this.r));
                g.listen("click", runOn(this, this.ak));
            }
        }
        ag() {
            if (this.f != null) {
                let a = this.g.getChildAt(1);
                this.a.be(this.f, a);
            }
        }
        ae() {
            if (this.f != null) {
                this.a.bb(this.f, this.g, this.b);
                for (let a = 2; a < 8; a++) {
                    let b = this.g.getChildAt(a);
                    for (let c = 0; c < 7; c++) {
                        let d = b.getChildAt(c);
                        d.listen("click", runOn(this, this.o));
                    }
                }
            }
        }
        ad() {
            if (this.f != null) {
                this.a.a9(this.c._inner[1]);
                this.a.bh(this.c._inner[2]);
            }
        }
        aa() {
            if (this.f != null) {
                this.a.bb(this.f, this.g, this.b);
            }
        }
        ac() {
            if (this.d.count != 0) {
                this.a.bd(this.d);
            }
        }
        ah() {
            if (this.e.count != 0) {
                this.a.bg(this.e);
            }
        }
        z() {
            this.aa();
            this.ad();
            this.l = "day";
            this.g.show();
            this.i.hide();
            this.j.hide();
            this.p();
        }
        ab(a) {
            this.h = a;
        }
        p() {
            if (this.h != null) {
                this.h.parent().parent().focus(false);
            }
        }
        y() {
            this.a.an(-1);
            this.aa();
            this.ad();
        }
        t() {
            this.a.an(1);
            this.aa();
            this.ad();
        }
        m(a) {
            let b = a.which;
            if (this.l == "day") {
                let c = this.h.getAttribute("data-section").toString();
                let d = parseInt(this.h.getAttribute("data-index").toString());
                if (c == "header") {
                    if (b == 37) {
                        if (d > 0) {
                            let e = this.c._inner[d - 1];
                            this.ab(e);
                            this.p();
                        }
                    }
                    else if (b == 39) {
                        if (d < 3) {
                            let f = this.c._inner[d + 1];
                            this.ab(f);
                            this.p();
                        }
                    }
                    else if (b == 9) {
                        a.preventDefault();
                        this.aa();
                        this.p();
                    }
                }
                else if (c == "days") {
                    let g = this.h.getAttribute("data-day").toString();
                    let h = this.h.getAttribute("data-month").toString();
                    if (b == 37) {
                        if (d == 0) {
                            this.y();
                        }
                        else {
                            let i = this.b._inner[d - 1];
                            let j = i.getAttribute("data-day").toString();
                            let k = i.getAttribute("data-month").toString();
                            if (h == k) {
                                this.ab(i);
                                this.p();
                            }
                            else {
                                this.y();
                                let l = this.k(j, k);
                                this.ab(l);
                                this.p();
                            }
                        }
                    }
                    else if (b == 39) {
                        if (d == 41) {
                            this.t();
                        }
                        else {
                            let m = this.b._inner[d + 1];
                            let n = m.getAttribute("data-day").toString();
                            let o = m.getAttribute("data-month").toString();
                            if (h == o) {
                                this.ab(m);
                                this.p();
                            }
                            else {
                                this.t();
                                let p = this.k(n, o);
                                this.ab(p);
                                this.p();
                            }
                        }
                    }
                    else if (b == 40) {
                        if (d >= 35) {
                            this.t();
                            let q = this.k(g, h);
                            let r = parseInt(q.getAttribute("data-index").toString());
                            let s = this.b._inner[r + 7];
                            let t = s.getAttribute("data-day").toString();
                            let u = s.getAttribute("data-month").toString();
                            let v = this.k(t, u);
                            this.ab(v);
                            this.p();
                        }
                        else {
                            let w = this.b._inner[d + 7];
                            let x = w.getAttribute("data-day").toString();
                            let y = w.getAttribute("data-month").toString();
                            if (h == y) {
                                this.ab(w);
                                this.p();
                            }
                            else {
                                this.t();
                                let z = this.k(x, y);
                                this.ab(z);
                                this.p();
                            }
                        }
                    }
                    else if (b == 38) {
                        if (d <= 6) {
                            this.y();
                            let aa = this.k(g, h);
                            let ab = parseInt(aa.getAttribute("data-index").toString());
                            let ac = this.b._inner[ab - 7];
                            let ad = ac.getAttribute("data-day").toString();
                            let ae = ac.getAttribute("data-month").toString();
                            let af = this.k(ad, ae);
                            this.ab(af);
                            this.p();
                        }
                        else {
                            let ag = this.b._inner[d - 7];
                            let ah = ag.getAttribute("data-day").toString();
                            let ai = ag.getAttribute("data-month").toString();
                            if (h == ai) {
                                this.ab(ag);
                                this.p();
                            }
                            else {
                                this.y();
                                let aj = this.k(ah, ai);
                                this.ab(aj);
                                this.p();
                            }
                        }
                    }
                    else if (b == 34) {
                        this.t();
                    }
                    else if (b == 33) {
                        this.y();
                    }
                    else if (b == 9) {
                        a.preventDefault();
                        let ak = this.c._inner[1];
                        this.ab(ak);
                        this.p();
                    }
                }
            }
            else if (this.l == "month") {
                let al = parseInt(this.h.getAttribute("data-index").toString());
                if (b == 37) {
                    if (al == 0) {
                        let am = this.d._inner[11];
                        this.ab(am);
                        this.p();
                    }
                    else {
                        let an = this.d._inner[al - 1];
                        this.ab(an);
                        this.p();
                    }
                }
                else if (b == 39) {
                    if (al == 11) {
                        let ao = this.d._inner[0];
                        this.ab(ao);
                        this.p();
                    }
                    else {
                        let ap = this.d._inner[al + 1];
                        this.ab(ap);
                        this.p();
                    }
                }
                else if (b == 40) {
                    if (al >= 9) {
                        let aq = this.d._inner[al - 9];
                        this.ab(aq);
                        this.p();
                    }
                    else {
                        let ar = this.d._inner[al + 3];
                        this.ab(ar);
                        this.p();
                    }
                }
                else if (b == 38) {
                    if (al <= 2) {
                        let as = this.d._inner[al + 9];
                        this.ab(as);
                        this.p();
                    }
                    else {
                        let at = this.d._inner[al - 3];
                        this.ab(at);
                        this.p();
                    }
                }
            }
            else if (this.l == "year") {
                let au = parseInt(this.h.getAttribute("data-index").toString());
                if (b == 40) {
                    this.a.a7(this.e, 1);
                }
                else if (b == 38) {
                    this.a.a7(this.e, -1);
                }
            }
            if (b == 27) {
                this.z();
                this.a.a0();
            }
        }
        k(a, b) {
            let c = null;
            for (let d = 0; d < 42; d++) {
                let e = this.b._inner[d];
                let f = e.getAttribute("data-day").toString();
                let g = e.getAttribute("data-month").toString();
                if (b == g && a == f) {
                    c = e;
                    break;
                }
            }
            return c;
        }
        x(a) {
            this.y();
        }
        s(a) {
            this.t();
        }
        r(a) {
            this.g.hide();
            this.i.show();
            this.i.setStyleProperty("display", "flex");
            this.j.hide();
            this.l = "month";
            this.ac();
            this.p();
        }
        ak(a) {
            this.g.hide();
            this.i.hide();
            this.j.show();
            this.l = "year";
            this.ah();
            this.p();
        }
        o(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.innerText;
            let c = a.lastChild.lastChild.lastChild;
            let d = c.getAttribute("data-month").toString();
            let e = c.getAttribute("data-year").toString();
            if (b != "") {
                this.a.aw(b, d, e);
            }
        }
        q(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.getAttribute("data-month").toString();
            if (b != "") {
                this.a.ao(parseInt(b));
                this.z();
            }
        }
        ai(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.innerText;
            if (b != "") {
                this.a.ap(parseInt(b));
                this.z();
            }
        }
        aj(e_) {
            let a = (e_.originalEvent.deltaY);
            this.a.a7(this.e, a);
        }
        u() {
        }
    }
    CalendarView.$t = /*@__PURE__*/ markType(CalendarView, 'CalendarView');
    return CalendarView;
})();
/**
 * @hidden
 */
export let Calendar = /*@__PURE__*/ (() => {
    class Calendar extends Base {
        constructor() {
            super();
            this.h = null;
            this.u = dateNow();
            this.t = dateNow();
            this.s = new Date();
            this.o = null;
            this.p = null;
            this.n = null;
            this.q = null;
            this.r = null;
            this.m = null;
            this.propertyChanged = null;
            this.close = null;
            this.valueChanged = null;
            this.x = toNullable(Date_$type, null);
            this.c = 2;
            this.a = 1;
            this.bm = BrushUtil.g(255, 33, 150, 243);
            this.bo = BrushUtil.g(255, 21, 112, 184);
            this.bk = BrushUtil.g(76, 33, 150, 243);
            this.bn = BrushUtil.g(255, 255, 255, 255);
            this.bl = BrushUtil.g(255, 24, 29, 31);
            this.bj = BrushUtil.g(255, 33, 150, 243);
            this.k = null;
            this.s = dateAddYears(this.s, -200);
            this.o = new ObservableCollection$1(DayInfo.$, 0);
            this.p = new ObservableCollection$1(Button.$, 0);
            this.n = new ObservableCollection$1(Button.$, 0);
            this.q = new ObservableCollection$1(Button.$, 0);
            this.r = new ObservableCollection$1(Button.$, 0);
            let a = new CalendarView();
            a.a = this;
            this.h = a;
            this.h.w();
        }
        a0() {
            if (this.close != null) {
                this.close(this);
            }
        }
        a2(a) {
            this.x = toNullable(Date_$type, a);
            if (this.valueChanged != null) {
                this.valueChanged(this, ((() => {
                    let $ret = new ValueChangedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
            this.u = this.x.value;
            this.a5();
        }
        aw(a, b, c) {
            let d = dateFromValues(parseInt(c), parseInt(b), parseInt(a), 0, 0, 0, 0);
            this.a2(d);
        }
        notifySizeChanged() {
            this.h.u();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.h.v(a);
        }
        get v() {
            return this.x.value;
        }
        set v(a) {
            let b = this.x;
            this.x = toNullable(Date_$type, a);
            if (nullableNotEquals(b, this.x)) {
                this.a1("Value", unwrapNullable(b), unwrapNullable(this.x));
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.a1("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.c));
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.a1("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.a));
            }
        }
        get bs() {
            return this.bm;
        }
        set bs(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.a1("SelectedDateBackgroundColor", b, this.bm);
            }
        }
        get bu() {
            return this.bo;
        }
        set bu(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.a1("SelectedFocusDateBackgroundColor", b, this.bo);
            }
        }
        get bq() {
            return this.bk;
        }
        set bq(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.a1("FocusDateBackgroundColor", b, this.bk);
            }
        }
        get bt() {
            return this.bn;
        }
        set bt(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.a1("SelectedDateTextColor", b, this.bn);
            }
        }
        get br() {
            return this.bl;
        }
        set br(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.a1("FocusDateTextColor", b, this.bl);
            }
        }
        get bp() {
            return this.bj;
        }
        set bp(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.a1("CurrentDateTextColor", b, this.bj);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.a1("TextStyle", b, this.k);
            }
        }
        a1(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.a3(a, b, c);
        }
        a3(a, b, c) {
            switch (a) {
                case "Density":
                    this.a8();
                    break;
                case "BaseTheme":
                    this.ba();
                    break;
                case "Value":
                    this.u = this.x.value;
                    this.a5();
                    break;
                case "SelectedDateBackgroundColor":
                case "SelectedDateTextColor":
                case "SelectedFocusDateBackgroundColor":
                case "FocusDateBackgroundColor":
                case "FocusDateTextColor":
                case "CurrentDateTextColor": break;
                case "TextStyle":
                    this.bi();
                    break;
            }
        }
        bi() {
            for (let a = 0; a < this.p.count; a++) {
                if (this.k != null) {
                    this.p._inner[a].v = this.k;
                }
            }
            for (let b = 0; b < this.n.count; b++) {
                if (this.k != null) {
                    this.n._inner[b].v = this.k;
                }
            }
            for (let c = 0; c < this.q.count; c++) {
                if (this.k != null) {
                    this.q._inner[c].v = this.k;
                }
            }
            for (let d = 0; d < this.r.count; d++) {
                if (this.k != null) {
                    this.r._inner[d].v = this.k;
                }
            }
        }
        ay() {
            this.h.p();
        }
        ba() {
        }
        a8() {
        }
        aq() {
        }
        av() {
            this.x = toNullable(Date_$type, null);
            this.h.aa();
        }
        a5() {
            this.as();
            this.h.ad();
            this.h.ah();
            this.h.aa();
        }
        ar(a, b, c) {
            let d = a.createElement("div");
            d.setStyleProperty("height", "14%");
            d.setStyleProperty("display", "flex");
            d.setStyleProperty("justify-content", "space-evenly");
            let e = a.createElement("div");
            let f = a.createElement("div");
            let g = a.createElement("div");
            let h = a.createElement("div");
            d.append(e);
            d.append(f);
            d.append(g);
            d.append(h);
            b.append(d);
            let i = 0;
            for (let j = 0; j < 7; j++) {
                let k = a.createElement("div");
                k.setStyleProperty("display", "flex");
                k.setStyleProperty("justify-content", "space-evenly");
                if (j == 0) {
                    k.setStyleProperty("height", "8%");
                    for (let l = 0; l < 7; l++) {
                        let m = a.createElement("div");
                        m.setStyleProperty("text-align", "center");
                        m.setStyleProperty("vertical-align", "middle");
                        m.setStyleProperty("width", "14%");
                        let n = a.createElement("span");
                        n.setStyleProperty("font", "16px \"Segoe UI\", Verdana");
                        n.setStyleProperty("color", "rgb(24, 29, 31)");
                        m.append(n);
                        k.append(m);
                    }
                }
                else {
                    k.setStyleProperty("height", "13%");
                    for (let o = 0; o < 7; o++) {
                        let p = a.createElement("div");
                        let q = c._inner[i];
                        let r = this.g(a, p, q, 4);
                        this.n.add(r);
                        r.h9 = "btnDays" + o.toString();
                        p.setStyleProperty("width", "14%");
                        p.setStyleProperty("height", "100%");
                        k.append(p);
                        i++;
                    }
                }
                b.append(k);
            }
            this.as();
        }
        at(a, b, c) {
            b.setStyleProperty("display", "flex");
            b.setStyleProperty("flex-direction", "row");
            b.setStyleProperty("flex-wrap", "wrap");
            b.setStyleProperty("margin", "2px");
            for (let d = 0; d < 12; d++) {
                let e = a.createElement("div");
                e.setAttribute("data-month", (d + 1).toString());
                let f = c._inner[d];
                let g = this.g(a, e, f, 1);
                this.q.add(g);
                e.setStyleProperty("width", "33%");
                let h = e.getChildAt(0);
                h.setStyleProperty("width", "100%");
                let i = f.getChildAt(0);
                let j = "";
                let k = d + 1;
                switch (k) {
                    case 1:
                        j = "Jan";
                        break;
                    case 2:
                        j = "Feb";
                        break;
                    case 3:
                        j = "Mar";
                        break;
                    case 4:
                        j = "Apr";
                        break;
                    case 5:
                        j = "May";
                        break;
                    case 6:
                        j = "Jun";
                        break;
                    case 7:
                        j = "Jul";
                        break;
                    case 8:
                        j = "Aug";
                        break;
                    case 9:
                        j = "Sep";
                        break;
                    case 10:
                        j = "Oct";
                        break;
                    case 11:
                        j = "Nov";
                        break;
                    case 12:
                        j = "Dec";
                        break;
                }
                g.h9 = "btnMonth" + j;
                i.setText(j);
                if (nullableNotEquals(this.x, null) && dateGetMonth(this.x.value) == k) {
                    g.sy = this.bj;
                    g.su = this.bj;
                    g.so = BrushUtil.g(0, 255, 255, 255);
                    g.st = this.bk;
                }
                else {
                    g.sy = BrushUtil.g(255, 24, 29, 31);
                    g.su = this.bl;
                    g.so = BrushUtil.g(0, 255, 255, 255);
                    g.st = this.bk;
                }
                f.setAttribute("data-index", d.toString());
                f.append(i);
                b.append(e);
            }
        }
        au(a, b, c) {
            let d = this.u.getFullYear() - 3;
            for (let e = 0; e < 7; e++) {
                let f = a.createElement("div");
                let g = c._inner[e];
                let h = this.g(a, f, g, 1);
                this.r.add(h);
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "14%");
                f.setStyleProperty("justify-content", "space-around");
                let i = f.getChildAt(0);
                i.setStyleProperty("width", "100%");
                let j = g.getChildAt(0);
                h.h9 = "btnYear" + e.toString();
                j.setText(d.toString());
                if (e == 3) {
                    h.sy = this.bj;
                    h.su = this.bj;
                    h.st = BrushUtil.g(0, 255, 255, 255);
                    h.sv = BrushUtil.g(0, 255, 255, 255);
                    h.sp = BrushUtil.g(0, 255, 255, 255);
                }
                else {
                    h.sy = BrushUtil.g(255, 24, 29, 31);
                    h.su = this.bl;
                    h.st = BrushUtil.g(0, 255, 255, 255);
                    h.sv = BrushUtil.g(0, 255, 255, 255);
                    h.sp = BrushUtil.g(0, 255, 255, 255);
                }
                d++;
                g.setAttribute("data-index", e.toString());
                g.append(j);
                b.append(f);
            }
        }
        as() {
            this.o.clear();
            let a = dateAddDays(this.u, -(this.u.getDate() - 1));
            let b = a.getDay();
            a = dateAddDays(a, -b);
            while (this.o.count < 42) {
                let c = new DayInfo();
                c.b = a.getDate();
                c.c = dateGetMonth(a);
                c.d = a.getFullYear();
                c.a = a.getDay();
                this.o.add(c);
                a = dateAddDays(a, 1);
            }
        }
        bc(a, b, c) {
            let d = b.getChildAt(0);
            let e = c._inner[0];
            let f = this.f(a, d, e, Calendar.z);
            f.td = BrushUtil.g(255, 24, 29, 31);
            f.s9 = this.bl;
            f.s3 = BrushUtil.g(0, 255, 255, 255);
            f.s8 = this.bk;
            f.h9 = "btnPrev";
            this.p.add(f);
            e.setAttribute("data-section", "header");
            e.setAttribute("data-index", "0");
            let g = b.getChildAt(1);
            let h = c._inner[1];
            let i = this.g(a, g, h, 1);
            i.sy = BrushUtil.g(255, 24, 29, 31);
            i.su = this.bl;
            i.so = BrushUtil.g(0, 255, 255, 255);
            i.st = this.bk;
            i.h9 = "btnMonth";
            this.p.add(i);
            h.setAttribute("data-section", "header");
            h.setAttribute("data-index", "1");
            this.a9(h);
            let j = b.getChildAt(2);
            let k = c._inner[2];
            let l = this.g(a, j, k, 1);
            l.sy = BrushUtil.g(255, 24, 29, 31);
            l.su = this.bl;
            l.so = BrushUtil.g(0, 255, 255, 255);
            l.st = this.bk;
            l.h9 = "btnYear";
            this.p.add(l);
            k.setAttribute("data-section", "header");
            k.setAttribute("data-index", "2");
            this.bh(k);
            let m = b.getChildAt(3);
            let n = c._inner[3];
            let o = this.f(a, m, n, Calendar.aa);
            o.td = BrushUtil.g(255, 24, 29, 31);
            o.s9 = this.bl;
            o.s3 = BrushUtil.g(0, 255, 255, 255);
            o.s8 = this.bk;
            o.h9 = "btnNext";
            this.p.add(o);
            n.setAttribute("data-section", "header");
            n.setAttribute("data-index", "3");
        }
        a9(a) {
            let b = a.getChildAt(0);
            let c = dateGetMonth(this.u);
            let d = "";
            switch (c) {
                case 1:
                    d = "Jan";
                    break;
                case 2:
                    d = "Feb";
                    break;
                case 3:
                    d = "Mar";
                    break;
                case 4:
                    d = "Apr";
                    break;
                case 5:
                    d = "May";
                    break;
                case 6:
                    d = "Jun";
                    break;
                case 7:
                    d = "Jul";
                    break;
                case 8:
                    d = "Aug";
                    break;
                case 9:
                    d = "Sep";
                    break;
                case 10:
                    d = "Oct";
                    break;
                case 11:
                    d = "Nov";
                    break;
                case 12:
                    d = "Dec";
                    break;
            }
            b.setText(d);
        }
        bh(a) {
            let b = a.getChildAt(0);
            let c = this.u.getFullYear().toString();
            b.setText(c);
        }
        be(a, b) {
            let c = b.getChildAt(0);
            let d = c.getChildAt(0);
            d.setText("S");
            c.append(d);
            let e = b.getChildAt(1);
            let f = e.getChildAt(0);
            f.setText("M");
            e.append(f);
            let g = b.getChildAt(2);
            let h = g.getChildAt(0);
            h.setText("T");
            g.append(h);
            let i = b.getChildAt(3);
            let j = i.getChildAt(0);
            j.setText("W");
            i.append(j);
            let k = b.getChildAt(4);
            let l = k.getChildAt(0);
            l.setText("T");
            k.append(l);
            let m = b.getChildAt(5);
            let n = m.getChildAt(0);
            n.setText("F");
            m.append(n);
            let o = b.getChildAt(6);
            let p = o.getChildAt(0);
            p.setText("S");
            o.append(p);
        }
        bb(a, b, c) {
            let d = null;
            let e = null;
            let f = null;
            for (let g = 0; g < 42; g++) {
                let h = c._inner[g];
                let i = h.getChildAt(0);
                let j = this.o._inner[g];
                let k = this.n._inner[g];
                if (j != null) {
                    h.setAttribute("data-section", "days");
                    h.setAttribute("data-index", g.toString());
                    h.setAttribute("data-day", j.b.toString());
                    h.setAttribute("data-month", j.c.toString());
                    h.setAttribute("data-year", j.d.toString());
                    i.setText(j.b.toString());
                    if (nullableNotEquals(this.x, null) && j.b == this.x.value.getDate() && j.c == dateGetMonth(this.x.value) && j.d == this.x.value.getFullYear()) {
                        k.td = this.bn;
                        k.s9 = this.bn;
                        k.s3 = this.bm;
                        k.s8 = this.bo;
                        d = h;
                    }
                    else if (j.b == this.s.getDate() && j.c == dateGetMonth(this.s) && j.d == this.s.getFullYear()) {
                        k.td = this.bl;
                        k.s9 = this.bl;
                        k.s3 = BrushUtil.g(0, 255, 255, 255);
                        k.s8 = this.bk;
                    }
                    else if (j.b == this.t.getDate() && j.c == dateGetMonth(this.t) && j.d == this.t.getFullYear()) {
                        k.td = this.bj;
                        k.s9 = this.bl;
                        k.s3 = BrushUtil.g(0, 255, 255, 255);
                        k.s8 = this.bk;
                        e = h;
                    }
                    else if (j.a != 0 && j.a != 6 && j.c == dateGetMonth(this.u)) {
                        k.td = BrushUtil.g(255, 24, 29, 31);
                        k.s9 = this.bl;
                        k.s3 = BrushUtil.g(0, 255, 255, 255);
                        k.s8 = this.bk;
                    }
                    else {
                        k.td = BrushUtil.g(255, 163, 172, 184);
                        k.s9 = this.bl;
                        k.s3 = BrushUtil.g(0, 255, 255, 255);
                        k.s8 = this.bk;
                    }
                    if (j.b == 1 && j.c == dateGetMonth(this.u)) {
                        f = h;
                    }
                }
            }
            if (d != null && nullableNotEquals(this.x, null) && this.x.value.getFullYear() == this.u.getFullYear() && dateGetMonth(this.x.value) == dateGetMonth(this.u)) {
                this.h.ab(d);
            }
            else if (e != null && this.t.getFullYear() == this.u.getFullYear() && dateGetMonth(this.t) == dateGetMonth(this.u)) {
                this.h.ab(e);
            }
            else if (f != null) {
                this.h.ab(f);
            }
        }
        bd(a) {
            let b = null;
            let c = null;
            for (let d = 0; d < 12; d++) {
                let e = a._inner[d];
                let f = e.getChildAt(0);
                let g = this.q._inner[d];
                if (nullableNotEquals(this.x, null) && dateGetMonth(this.x.value) == d + 1) {
                    g.sy = this.bj;
                    g.su = this.bj;
                    g.so = BrushUtil.g(0, 255, 255, 255);
                    g.st = this.bk;
                    c = e;
                }
                else {
                    g.sy = BrushUtil.g(255, 24, 29, 31);
                    g.su = this.bl;
                    g.so = BrushUtil.g(0, 255, 255, 255);
                    g.st = this.bk;
                }
                if (dateGetMonth(this.t) == d + 1) {
                    b = e;
                }
            }
            if (c != null) {
                this.h.ab(c);
            }
            else if (b != null) {
                this.h.ab(b);
            }
            else {
                this.h.ab(a._inner[0]);
            }
        }
        bg(a) {
            this.bf(a, this.u.getFullYear(), true);
        }
        bf(a, b, c = false) {
            let d = b - 3;
            for (let e = 0; e < 7; e++) {
                let f = a._inner[e];
                let g = f.getChildAt(0);
                g.setText(d.toString());
                if (d == b && c) {
                    this.h.ab(f);
                }
                if (e == 3) {
                }
                else {
                }
                d++;
            }
        }
        g(a, b, c, d) {
            let e = a.getSubRenderer(b);
            let f = new Button();
            f.provideContainer(e);
            f.d = this.b;
            f.h = this.d;
            f.s = d;
            if (this.k != null) {
                f.v = this.k;
            }
            let g = a.createElement("span");
            let h = new CornerRadius(0, 25);
            f.j7 = h;
            c.append(g);
            f.appendButtonContent(c);
            return f;
        }
        f(a, b, c, d) {
            let e = a.getSubRenderer(b);
            let f = new Button();
            f.provideContainer(e);
            f.d = this.b;
            f.h = this.d;
            f.s = 4;
            let g = a.createElement("div");
            let h = a.getSubRenderer(g);
            let i = new Icon();
            i.provideContainer(h);
            i.svgPath = d;
            c.append(g);
            f.appendButtonContent(c);
            return f;
        }
        an(a) {
            this.u = dateAddMonths(this.u, a);
            this.as();
        }
        ao(a) {
            this.u = dateFromValues(this.u.getFullYear(), a, this.u.getDate(), 0, 0, 0, 0);
            this.as();
        }
        ap(a) {
            this.u = dateFromValues(a, dateGetMonth(this.u), this.u.getDate(), 0, 0, 0, 0);
            this.as();
        }
        a7(a, b) {
            let c = parseInt(a._inner[3].getChildAt(0).getText());
            if (b < 0) {
                c--;
            }
            else {
                c++;
            }
            this.bf(a, c);
        }
        a6() {
            this.h.z();
        }
        y() {
            return this.e();
        }
        af() {
            let a = this.e();
            return a.k();
        }
        e() {
            let a = new CalendarVisualModelExport();
            a.h = this.d;
            a.g = this.b;
            a.d = AppearanceHelper.a(this.bs);
            a.f = AppearanceHelper.a(this.bu);
            a.b = AppearanceHelper.a(this.bq);
            a.e = AppearanceHelper.a(this.bt);
            a.c = AppearanceHelper.a(this.br);
            a.a = AppearanceHelper.a(this.bp);
            a.i = new List$1(ButtonVisualModelExport.$, 0);
            for (let b = 0; b < this.p.count; b++) {
                if (this.p._inner[b].h9 == null) {
                    this.p._inner[b].h9 = "header" + b.toString();
                }
                a.i.add1(this.p._inner[b].eu());
            }
            for (let c = 0; c < this.n.count; c++) {
                if (this.n._inner[c].h9 == null) {
                    this.n._inner[c].h9 = "days" + c.toString();
                }
                a.i.add1(this.n._inner[c].eu());
            }
            for (let d = 0; d < this.q.count; d++) {
                if (this.q._inner[d].h9 == null) {
                    this.q._inner[d].h9 = "months" + d.toString();
                }
                a.i.add1(this.q._inner[d].eu());
            }
            for (let e = 0; e < this.r.count; e++) {
                if (this.r._inner[e].h9 == null) {
                    this.r._inner[e].h9 = "years" + e.toString();
                }
                a.i.add1(this.r._inner[e].eu());
            }
            if (this.l != null) {
                let f = this.l;
                if (this.h != null && f.n == null) {
                    let g = this.h.f;
                    let h = FontUtil.getFontInfoFromString(g, f.fontString);
                    f.n = h.n;
                    f.d = h.d;
                    f.o = h.o;
                    f.q = h.q;
                    f.r = h.r;
                    f.s = h.s;
                }
                if (f.n != null) {
                    a.l = f.n;
                }
                if (!isNaN_(f.d)) {
                    a.j = f.d;
                }
                if (f.s != null) {
                    a.p = f.s;
                }
                if (f.q != null) {
                    a.n = f.q;
                }
                if (f.o != null) {
                    a.m = f.q;
                }
            }
            return a;
        }
    }
    Calendar.$t = /*@__PURE__*/ markType(Calendar, 'Calendar', Base.$, [INotifyPropertyChanged_$type]);
    Calendar.z = "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z";
    Calendar.aa = "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z";
    return Calendar;
})();
//# sourceMappingURL=CalendarView_combined.js.map
