/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, toNullable, Date_$type, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { Popup } from "igniteui-react-layouts";
import { Input } from "./Input";
import { Calendar } from "./Calendar";
import { Suffix } from "./Suffix";
import { InputGroup } from "./InputGroup";
import { Icon } from "./Icon";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { nullableNotEquals, unwrapNullable } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let DatePickerView = /*@__PURE__*/ (() => {
    class DatePickerView extends Base {
        constructor() {
            super();
            this.a = null;
            this.c = null;
            this.f = null;
            this.d = null;
            this.e = null;
        }
        o() {
        }
        n(a) {
            if (a == null) {
                this.c = null;
                return;
            }
            this.c = a;
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.i();
            this.j();
            let d = this.c.rootWrapper.getChildAt(0);
            d.listen("keydown", runOn(this, this.g));
            document.addEventListener("click", runOn(this, this.k), false);
        }
        i() {
            if (this.c != null) {
                this.f = this.c.rootWrapper.getChildAt(0);
                this.e = this.c.createElement("div");
                let a = this.c.createElement("div");
                this.a.ak(this.c, this.f, this.e, a);
                this.e.listen("click", runOn(this, this.h));
                a.listen("click", runOn(this, this.l));
            }
        }
        q() {
            if (this.e != null) {
                if (this.a.q == true) {
                    this.e.show();
                }
                else {
                    this.e.hide();
                }
            }
        }
        j() {
            if (this.c != null) {
                let a = this.c.rootWrapper.getChildAt(1);
                this.a.al(this.c, a);
            }
        }
        h(a) {
            this.a.ai();
            if (this.e != null) {
                this.e.hide();
            }
        }
        l(a) {
            this.a.an();
        }
        r() {
            if (this.c != null) {
                let a = this.c.rootWrapper.getNativeElement();
                let b = a.getBoundingClientRect();
                ;
                return b;
            }
            return null;
        }
        g(a) {
            let b = a.which;
            if (a.altKey) {
                if (b == 40) {
                    this.a.ar();
                }
            }
            else if (b == 27) {
                this.a.aj();
            }
        }
        k(a) {
            let b = a.target;
            if (!this.b(b)) {
                this.a.aj();
            }
        }
        b(a) {
            if (null == a) {
                return false;
            }
            let b = this.f.getNativeElement();
            let c = this.d.getNativeElement();
            return b.contains(a) || c.contains(a);
        }
        p(a) {
            this.d = a;
        }
        m() {
        }
    }
    DatePickerView.$t = /*@__PURE__*/ markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
})();
/**
 * @hidden
 */
export let DatePicker = /*@__PURE__*/ (() => {
    class DatePicker extends Base {
        constructor() {
            super();
            this.g = null;
            this.m = null;
            this.k = null;
            this.j = null;
            this.h = null;
            this.i = null;
            this.f = null;
            this.propertyChanged = null;
            this.valueChanged = null;
            this.t = toNullable(Date_$type, null);
            this.c = 2;
            this.a = 1;
            this.n = null;
            this.p = true;
            let a = new DatePickerView();
            a.a = this;
            this.g = a;
            this.g.o();
        }
        aq(a) {
            this.t = toNullable(Date_$type, a);
            if (this.m != null) {
                this.aj();
            }
            if (this.j != null) {
                this.j.cf = dateToStringFormat(this.t.value, "MM/dd/yyyy", null);
            }
            this.g.q();
            if (this.valueChanged != null) {
                this.valueChanged(this, ((() => {
                    let $ret = new ValueChangedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        notifySizeChanged() {
            this.g.m();
        }
        destroy() {
            if (this.f != null) {
                let a = this.f;
                a.valueChanged = delegateRemove(a.valueChanged, runOn(this, this.ah));
            }
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.g.n(a);
        }
        get r() {
            return this.t.value;
        }
        set r(a) {
            let b = this.t;
            this.t = toNullable(Date_$type, a);
            if (nullableNotEquals(b, this.t)) {
                this.ap("Value", unwrapNullable(b), unwrapNullable(this.t));
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ap("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.c));
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ap("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.a));
            }
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.ap("TextStyle", b, this.n);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ap("ShowClearButton", b, this.p);
            }
        }
        ap(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.as(a, b, c);
        }
        as(a, b, c) {
            switch (a) {
                case "Density":
                    this.au();
                    break;
                case "BaseTheme":
                    this.av();
                    break;
                case "Value":
                    if (this.f != null) {
                        this.f.v = this.t.value;
                    }
                    if (this.j != null) {
                        this.j.cf = dateToStringFormat(this.t.value, "MM/dd/yyyy", null);
                    }
                    break;
                case "TextStyle":
                    this.aw();
                    break;
                case "ShowClearButton":
                    this.g.q();
                    break;
            }
        }
        aw() {
            if (this.n != null) {
                this.j.ac = this.n;
            }
        }
        ak(a, b, c, d) {
            b.setStyleProperty("display", "flex");
            b.setStyleProperty("height", "100%");
            this.k = new InputGroup();
            let e = a.getSubRenderer(b);
            this.k.provideContainer(e);
            this.k.k = 0;
            this.k.d = this.b;
            this.k.h = this.d;
            let f = a.createElement("div");
            f.setRawStyleProperty("flex-grow", "1");
            let g = a.getSubRenderer(f);
            this.j = new Input();
            this.j.provideContainer(g);
            this.j.b0 = "text";
            let h = this.j;
            h.gotFocus = delegateCombine(h.gotFocus, runOn(this, this.af));
            if (this.n != null) {
                this.j.ac = this.n;
            }
            this.j.disabled = true;
            this.k.appendContentChild(f);
            this.k.inputs.add(this.j);
            let i = a.createElement("div");
            let j = a.getSubRenderer(i);
            let k = new Suffix();
            k.provideContainer(j);
            this.h = new Icon();
            let l = a.getSubRenderer(c);
            this.h.provideContainer(l);
            this.h.svgPath = DatePicker.w;
            k.appendContentChild(c);
            this.k.appendContentChild(i);
            this.k.inputs.add(k);
            c.hide();
            let m = a.createElement("div");
            let n = a.getSubRenderer(m);
            let o = new Suffix();
            o.provideContainer(n);
            let p = a.getSubRenderer(d);
            this.i = new Icon();
            this.i.provideContainer(p);
            this.i.svgPath = DatePicker.aa;
            o.appendContentChild(d);
            this.k.appendContentChild(m);
            this.k.inputs.add(o);
        }
        ai() {
            if (this.j != null) {
                this.j.cf = "";
            }
            this.t = toNullable(Date_$type, null);
            this.f.av();
        }
        af(a, b) {
            if (!this.m.t) {
                this.ar();
            }
        }
        al(a, b) {
            this.m = new Popup();
            let c = a.getSubRenderer(b);
            this.m.provideRenderer(c);
            this.f = new Calendar();
            let d = a.createElement("div");
            this.g.p(d);
            d.setStyleProperty("width", "280px");
            d.setStyleProperty("height", "280px");
            let e = a.getSubRenderer(d);
            this.f.provideContainer(e);
            let f = this.f;
            f.valueChanged = delegateCombine(f.valueChanged, runOn(this, this.ah));
            let g = this.f;
            g.close = delegateCombine(g.close, runOn(this, this.ag));
            this.m.appendPopupContent(d);
        }
        ah(a, b) {
            this.aq(b.a);
        }
        ag(a) {
            if (this.m.t) {
                this.aj();
            }
        }
        an() {
            if (this.m.t) {
                this.aj();
            }
            else {
                this.ar();
            }
        }
        ar() {
            let a = this.g.r();
            this.m.showRelativeToExclusionRect(a, 0, 0);
            this.i.svgPath = DatePicker.x;
            this.f.ay();
        }
        aj() {
            this.m.an();
            this.f.a6();
            this.i.svgPath = DatePicker.aa;
        }
        av() {
        }
        au() {
        }
        u() {
            return this.e();
        }
        ab() {
            let a = this.e();
            return a.g();
        }
        e() {
            let a = new DatePickerVisualModelExport();
            a.b = this.d;
            a.a = this.b;
            a.e = this.m.ab();
            a.d = this.k.ia();
            a.c = this.f.y();
            if (this.o != null) {
                let b = this.o;
                if (this.g != null && b.n == null) {
                    let c = this.g.c;
                    let d = FontUtil.getFontInfoFromString(c, b.fontString);
                    b.n = d.n;
                    b.d = d.d;
                    b.o = d.o;
                    b.q = d.q;
                    b.r = d.r;
                    b.s = d.s;
                }
                if (b.n != null) {
                    a.h = b.n;
                }
                if (!isNaN_(b.d)) {
                    a.f = b.d;
                }
                if (b.s != null) {
                    a.l = b.s;
                }
                if (b.q != null) {
                    a.j = b.q;
                }
                if (b.o != null) {
                    a.i = b.q;
                }
            }
            return a;
        }
    }
    DatePicker.$t = /*@__PURE__*/ markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.aa = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    DatePicker.x = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    DatePicker.w = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    return DatePicker;
})();
//# sourceMappingURL=DatePickerView_combined.js.map
