/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var ButtonVisualModelExport = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(ButtonVisualModelExport, _super);
    function ButtonVisualModelExport() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.q = 0;
        _this.o = 0;
        _this.p = 0;
        _this.c = null;
        _this.n = null;
        _this.k = null;
        _this.a = null;
        _this.ab = 0;
        _this.z = 0;
        _this.aa = 0;
        _this.l = null;
        _this.ao = null;
        _this.b = null;
        _this.d = null;
        _this.e = null;
        _this.f = null;
        _this.y = 0;
        _this.r = 0;
        _this.m = null;
        _this.j = null;
        _this.g = null;
        _this.h = null;
        _this.i = null;
        _this.w = 0;
        _this.al = null;
        _this.am = null;
        _this.an = null;
        _this.x = 0;
        _this.aj = null;
        _this.ak = null;
        _this.ae = null;
        _this.af = null;
        _this.ag = null;
        _this.ad = null;
        _this.ac = null;
        _this.ah = null;
        _this.u = false;
        _this.s = false;
        _this.v = false;
        _this.t = false;
        return _this;
    }
    ButtonVisualModelExport.prototype.ai = function () {
        var a = new StringBuilder(0);
        a.l("{");
        a.l("density : " + enumGetBox(ControlDisplayDensity_$type, this.q) + ", ");
        a.l("baseTheme : " + enumGetBox(BaseControlTheme_$type, this.o) + ", ");
        a.l("actualDensity : " + enumGetBox(ControlDisplayDensity_$type, this.p) + ", ");
        a.l("actualBorderColor : " + this.c.serialize() + ", ");
        a.l("actualUmbraShadowColor : " + this.n.serialize() + ", ");
        a.l("actualPenumbraShadowColor : " + this.k.serialize() + ", ");
        a.l("actualAmbientShadowColor : " + this.a.serialize() + ", ");
        a.l("actualRestingElevation : " + this.ab + ", ");
        a.l("actualFocusElevation : " + this.z + ", ");
        a.l("actualHoverElevation : " + this.aa + ", ");
        if (this.l != null) {
            a.l("actualRippleColor : " + this.l.serialize() + ", ");
        }
        a.l("actualCornerRadius : " + this.ao + ", ");
        a.l("actualBackgroundColor : " + this.b.serialize() + ", ");
        a.l("actualDisabledBackgroundColor : " + this.d.serialize() + ", ");
        a.l("actualDisabledBorderColor : " + this.e.serialize() + ", ");
        a.l("actualDisabledTextColor : " + this.f.serialize() + ", ");
        a.l("actualDisabledElevation : " + this.y + ", ");
        a.l("actualElevationMode : " + enumGetBox(ElevationMode_$type, this.r) + ", ");
        a.l("actualTextColor : " + this.m.serialize() + ", ");
        a.l("actualHoverTextColor : " + this.j.serialize() + ", ");
        a.l("actualFocusBackgroundColor : " + this.g.serialize() + ", ");
        a.l("actualFocusTextColor : " + this.h.serialize() + ", ");
        a.l("actualHoverBackgroundColor : " + this.i.serialize() + ", ");
        a.l("actualBorderWidth : " + this.w + ", ");
        if (!stringIsNullOrEmpty(this.al)) {
            a.l("textStyleFontStyle : \"" + this.al + "\", ");
        }
        if (!stringIsNullOrEmpty(this.am)) {
            a.l("textStyleFontVariant : \"" + this.am + "\", ");
        }
        if (!stringIsNullOrEmpty(this.an)) {
            a.l("textStyleFontWeight : \"" + this.an + "\", ");
        }
        if (!stringIsNullOrEmpty(this.aj)) {
            a.l("textStyleFontFamily : \"" + this.aj + "\", ");
        }
        if (!stringIsNullOrEmpty(this.ak)) {
            a.l("textStyleFontStretch : \"" + this.ak + "\", ");
        }
        if (!isNaN_(this.x)) {
            a.l("textStyleFontSize : " + this.x + ", ");
        }
        a.l("display : " + this.ae + ", ");
        a.l("flexDirection : " + this.af + ", ");
        a.l("flexGrow : " + this.ag + ", ");
        a.l("alignItems : " + this.ad + ", ");
        a.l("value : " + this.ac + ", ");
        a.l("name : " + this.ah + ", ");
        a.l("isFocused : " + this.u + ", ");
        a.l("actualDisableRipple : " + this.s + ", ");
        a.l("isHover : " + this.v + ", ");
        a.l("isDisabled : " + this.t + ", ");
        a.l("}");
        return a.toString();
    };
    ButtonVisualModelExport.$t = markType(ButtonVisualModelExport, 'ButtonVisualModelExport');
    return ButtonVisualModelExport;
}(Base));
export { ButtonVisualModelExport };
//# sourceMappingURL=ButtonVisualModelExport.js.map
