/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, toNullable, Date_$type, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { Popup } from "igniteui-react-layouts";
import { Input } from "./Input";
import { Calendar } from "./Calendar";
import { Suffix } from "./Suffix";
import { InputGroup } from "./InputGroup";
import { Icon } from "./Icon";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { nullableNotEquals, unwrapNullable } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var DatePickerView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(DatePickerView, _super);
    function DatePickerView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = null;
        _this.f = null;
        _this.d = null;
        _this.e = null;
        return _this;
    }
    DatePickerView.prototype.o = function () {
    };
    DatePickerView.prototype.n = function (a) {
        if (a == null) {
            this.c = null;
            return;
        }
        this.c = a;
        var b = Math.round(a.rootWrapper.width());
        var c = Math.round(a.rootWrapper.height());
        this.i();
        this.j();
        var d = this.c.rootWrapper.getChildAt(0);
        d.listen("keydown", runOn(this, this.g));
        document.addEventListener("click", runOn(this, this.k), false);
    };
    DatePickerView.prototype.i = function () {
        if (this.c != null) {
            this.f = this.c.rootWrapper.getChildAt(0);
            this.e = this.c.createElement("div");
            var a = this.c.createElement("div");
            this.a.ak(this.c, this.f, this.e, a);
            this.e.listen("click", runOn(this, this.h));
            a.listen("click", runOn(this, this.l));
        }
    };
    DatePickerView.prototype.q = function () {
        if (this.e != null) {
            if (this.a.q == true) {
                this.e.show();
            }
            else {
                this.e.hide();
            }
        }
    };
    DatePickerView.prototype.j = function () {
        if (this.c != null) {
            var a = this.c.rootWrapper.getChildAt(1);
            this.a.al(this.c, a);
        }
    };
    DatePickerView.prototype.h = function (a) {
        this.a.ai();
        if (this.e != null) {
            this.e.hide();
        }
    };
    DatePickerView.prototype.l = function (a) {
        this.a.an();
    };
    DatePickerView.prototype.r = function () {
        if (this.c != null) {
            var a = this.c.rootWrapper.getNativeElement();
            var b = a.getBoundingClientRect();
            ;
            return b;
        }
        return null;
    };
    DatePickerView.prototype.g = function (a) {
        var b = a.which;
        if (a.altKey) {
            if (b == 40) {
                this.a.ar();
            }
        }
        else if (b == 27) {
            this.a.aj();
        }
    };
    DatePickerView.prototype.k = function (a) {
        var b = a.target;
        if (!this.b(b)) {
            this.a.aj();
        }
    };
    DatePickerView.prototype.b = function (a) {
        if (null == a) {
            return false;
        }
        var b = this.f.getNativeElement();
        var c = this.d.getNativeElement();
        return b.contains(a) || c.contains(a);
    };
    DatePickerView.prototype.p = function (a) {
        this.d = a;
    };
    DatePickerView.prototype.m = function () {
    };
    DatePickerView.$t = markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
}(Base));
export { DatePickerView };
/**
 * @hidden
 */
var DatePicker = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(DatePicker, _super);
    function DatePicker() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.m = null;
        _this.k = null;
        _this.j = null;
        _this.h = null;
        _this.i = null;
        _this.f = null;
        _this.propertyChanged = null;
        _this.valueChanged = null;
        _this.t = toNullable(Date_$type, null);
        _this.c = 2;
        _this.a = 1;
        _this.n = null;
        _this.p = true;
        var a = new DatePickerView();
        a.a = _this;
        _this.g = a;
        _this.g.o();
        return _this;
    }
    DatePicker.prototype.aq = function (a) {
        this.t = toNullable(Date_$type, a);
        if (this.m != null) {
            this.aj();
        }
        if (this.j != null) {
            this.j.cf = dateToStringFormat(this.t.value, "MM/dd/yyyy", null);
        }
        this.g.q();
        if (this.valueChanged != null) {
            this.valueChanged(this, ((function () {
                var $ret = new ValueChangedEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
    };
    DatePicker.prototype.notifySizeChanged = function () {
        this.g.m();
    };
    DatePicker.prototype.destroy = function () {
        if (this.f != null) {
            var a = this.f;
            a.valueChanged = delegateRemove(a.valueChanged, runOn(this, this.ah));
        }
        this.provideContainer(null);
    };
    DatePicker.prototype.provideContainer = function (a) {
        this.g.n(a);
    };
    Object.defineProperty(DatePicker.prototype, "r", {
        get: function () {
            return this.t.value;
        },
        set: function (a) {
            var b = this.t;
            this.t = toNullable(Date_$type, a);
            if (nullableNotEquals(b, this.t)) {
                this.ap("Value", unwrapNullable(b), unwrapNullable(this.t));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ap("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.c));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ap("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "o", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.ap("TextStyle", b, this.n);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ap("ShowClearButton", b, this.p);
            }
        },
        enumerable: true,
        configurable: true
    });
    DatePicker.prototype.ap = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.as(a, b, c);
    };
    DatePicker.prototype.as = function (a, b, c) {
        switch (a) {
            case "Density":
                this.au();
                break;
            case "BaseTheme":
                this.av();
                break;
            case "Value":
                if (this.f != null) {
                    this.f.v = this.t.value;
                }
                if (this.j != null) {
                    this.j.cf = dateToStringFormat(this.t.value, "MM/dd/yyyy", null);
                }
                break;
            case "TextStyle":
                this.aw();
                break;
            case "ShowClearButton":
                this.g.q();
                break;
        }
    };
    DatePicker.prototype.aw = function () {
        if (this.n != null) {
            this.j.ac = this.n;
        }
    };
    DatePicker.prototype.ak = function (a, b, c, d) {
        b.setStyleProperty("display", "flex");
        b.setStyleProperty("height", "100%");
        this.k = new InputGroup();
        var e = a.getSubRenderer(b);
        this.k.provideContainer(e);
        this.k.k = 0;
        this.k.d = this.b;
        this.k.h = this.d;
        var f = a.createElement("div");
        f.setRawStyleProperty("flex-grow", "1");
        var g = a.getSubRenderer(f);
        this.j = new Input();
        this.j.provideContainer(g);
        this.j.b0 = "text";
        var h = this.j;
        h.gotFocus = delegateCombine(h.gotFocus, runOn(this, this.af));
        if (this.n != null) {
            this.j.ac = this.n;
        }
        this.j.disabled = true;
        this.k.appendContentChild(f);
        this.k.inputs.add(this.j);
        var i = a.createElement("div");
        var j = a.getSubRenderer(i);
        var k = new Suffix();
        k.provideContainer(j);
        this.h = new Icon();
        var l = a.getSubRenderer(c);
        this.h.provideContainer(l);
        this.h.svgPath = DatePicker.w;
        k.appendContentChild(c);
        this.k.appendContentChild(i);
        this.k.inputs.add(k);
        c.hide();
        var m = a.createElement("div");
        var n = a.getSubRenderer(m);
        var o = new Suffix();
        o.provideContainer(n);
        var p = a.getSubRenderer(d);
        this.i = new Icon();
        this.i.provideContainer(p);
        this.i.svgPath = DatePicker.aa;
        o.appendContentChild(d);
        this.k.appendContentChild(m);
        this.k.inputs.add(o);
    };
    DatePicker.prototype.ai = function () {
        if (this.j != null) {
            this.j.cf = "";
        }
        this.t = toNullable(Date_$type, null);
        this.f.av();
    };
    DatePicker.prototype.af = function (a, b) {
        if (!this.m.t) {
            this.ar();
        }
    };
    DatePicker.prototype.al = function (a, b) {
        this.m = new Popup();
        var c = a.getSubRenderer(b);
        this.m.provideRenderer(c);
        this.f = new Calendar();
        var d = a.createElement("div");
        this.g.p(d);
        d.setStyleProperty("width", "280px");
        d.setStyleProperty("height", "280px");
        var e = a.getSubRenderer(d);
        this.f.provideContainer(e);
        var f = this.f;
        f.valueChanged = delegateCombine(f.valueChanged, runOn(this, this.ah));
        var g = this.f;
        g.close = delegateCombine(g.close, runOn(this, this.ag));
        this.m.appendPopupContent(d);
    };
    DatePicker.prototype.ah = function (a, b) {
        this.aq(b.a);
    };
    DatePicker.prototype.ag = function (a) {
        if (this.m.t) {
            this.aj();
        }
    };
    DatePicker.prototype.an = function () {
        if (this.m.t) {
            this.aj();
        }
        else {
            this.ar();
        }
    };
    DatePicker.prototype.ar = function () {
        var a = this.g.r();
        this.m.showRelativeToExclusionRect(a, 0, 0);
        this.i.svgPath = DatePicker.x;
        this.f.ay();
    };
    DatePicker.prototype.aj = function () {
        this.m.an();
        this.f.a6();
        this.i.svgPath = DatePicker.aa;
    };
    DatePicker.prototype.av = function () {
    };
    DatePicker.prototype.au = function () {
    };
    DatePicker.prototype.u = function () {
        return this.e();
    };
    DatePicker.prototype.ab = function () {
        var a = this.e();
        return a.g();
    };
    DatePicker.prototype.e = function () {
        var a = new DatePickerVisualModelExport();
        a.b = this.d;
        a.a = this.b;
        a.e = this.m.ab();
        a.d = this.k.ia();
        a.c = this.f.y();
        if (this.o != null) {
            var b = this.o;
            if (this.g != null && b.n == null) {
                var c = this.g.c;
                var d = FontUtil.getFontInfoFromString(c, b.fontString);
                b.n = d.n;
                b.d = d.d;
                b.o = d.o;
                b.q = d.q;
                b.r = d.r;
                b.s = d.s;
            }
            if (b.n != null) {
                a.h = b.n;
            }
            if (!isNaN_(b.d)) {
                a.f = b.d;
            }
            if (b.s != null) {
                a.l = b.s;
            }
            if (b.q != null) {
                a.j = b.q;
            }
            if (b.o != null) {
                a.i = b.q;
            }
        }
        return a;
    };
    DatePicker.$t = markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.aa = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    DatePicker.x = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    DatePicker.w = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    return DatePicker;
}(Base));
export { DatePicker };
//# sourceMappingURL=DatePickerView_combined.js.map
