/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { LabelShiftType_$type } from "./LabelShiftType";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var LabelVisualModelExport = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(LabelVisualModelExport, _super);
    function LabelVisualModelExport() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = 0;
        _this.g = 0;
        _this.f = 0;
        _this.d = null;
        _this.a = null;
        _this.b = null;
        _this.c = null;
        _this.x = null;
        _this.y = null;
        _this.z = null;
        _this.n = 0;
        _this.v = null;
        _this.w = null;
        _this.h = 0;
        _this.l = false;
        _this.j = false;
        _this.p = null;
        _this.q = null;
        _this.r = null;
        _this.o = null;
        _this.u = null;
        _this.k = false;
        _this.m = false;
        _this.i = false;
        _this.s = null;
        return _this;
    }
    LabelVisualModelExport.prototype.t = function () {
        var a = new StringBuilder(0);
        a.l("{");
        a.l("baseTheme : " + enumGetBox(BaseControlTheme_$type, this.e) + ", ");
        a.l("density : " + enumGetBox(ControlDisplayDensity_$type, this.g) + ", ");
        a.l("actualDensity : " + enumGetBox(ControlDisplayDensity_$type, this.f) + ", ");
        a.l("actualTextColor : " + this.d.serialize() + ", ");
        a.l("actualHighlightTextColor : " + this.a.serialize() + ", ");
        a.l("actualHoverHighlightTextColor : " + this.b.serialize() + ", ");
        a.l("actualHoverTextColor : " + this.c.serialize() + ", ");
        if (!stringIsNullOrEmpty(this.x)) {
            a.l("textStyleFontStyle : \"" + this.x + "\", ");
        }
        if (!stringIsNullOrEmpty(this.y)) {
            a.l("textStyleFontVariant : \"" + this.y + "\", ");
        }
        if (!stringIsNullOrEmpty(this.z)) {
            a.l("textStyleFontWeight : \"" + this.z + "\", ");
        }
        if (!stringIsNullOrEmpty(this.v)) {
            a.l("textStyleFontFamily : \"" + this.v + "\", ");
        }
        if (!stringIsNullOrEmpty(this.w)) {
            a.l("textStyleFontStretch : \"" + this.w + "\", ");
        }
        if (!isNaN_(this.n)) {
            a.l("textStyleFontSize : " + this.n + ", ");
        }
        a.l("shiftType : " + enumGetBox(LabelShiftType_$type, this.h) + ", ");
        a.l("isShifted : " + this.l + ", ");
        a.l("isHighlighted : " + this.j + ", ");
        a.l("display : " + this.p + ", ");
        a.l("flexDirection : " + this.q + ", ");
        a.l("flexGrow : " + this.r + ", ");
        a.l("alignItems : " + this.o + ", ");
        a.l("text : " + this.u + ", ");
        a.l("isHover : " + this.k + ", ");
        a.l("value : " + this.m + ", ");
        a.l("isDisabled : " + this.i + ", ");
        a.l("name : " + this.s + ", ");
        a.l("}");
        return a.toString();
    };
    LabelVisualModelExport.$t = markType(LabelVisualModelExport, 'LabelVisualModelExport');
    return LabelVisualModelExport;
}(Base));
export { LabelVisualModelExport };
//# sourceMappingURL=LabelVisualModelExport.js.map
