import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { ElevationMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ButtonDisplayStyle } from "./ButtonDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
/**
 * @hidden
 */
export declare class ButtonView extends Base {
    static $t: Type;
    constructor();
    a: Button;
    ag(): void;
    f(): boolean;
    h: DomRenderer;
    private c;
    private g;
    readonly n: any;
    readonly o: any;
    aa(a: DomRenderer): void;
    ac(): void;
    an(): void;
    ai(): void;
    ad(): void;
    y(): void;
    ae(): void;
    af(): void;
    private p;
    ak(): void;
    ah(): void;
    private q;
    private r;
    private s;
    private v;
    private u;
    private e;
    private t;
    x(): void;
    private d;
    private k;
    private i;
    private b;
    private j;
    private m;
    private l;
    z(): void;
    ab(): void;
    aj(): void;
    al(a: Brush, b: Brush): void;
    am(a: number, b: ElevationMode): void;
    ao(a: FontInfo): void;
    w(a: any): void;
}
/**
 * @hidden
 */
export declare class Button extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    view: ButtonView;
    destroy(): void;
    protected jr(a: string, b: any, c: any): void;
    protected jt(a: string, b: any, c: any): void;
    private j6;
    private jw;
    jm(): void;
    jl(): void;
    jo(): void;
    jq(): void;
    jp(): void;
    private jv;
    private static rl;
    private static q9;
    private static p0;
    private static n;
    private static rc;
    private static rd;
    private static re;
    private static dq;
    private static dt;
    private static ds;
    private static dr;
    private static rb;
    private static rj;
    private static kk;
    private static a8;
    private static ra;
    private static rk;
    private static ri;
    private static rh;
    private static rf;
    private static rg;
    private static qe;
    private static qf;
    private static qg;
    private static dd;
    private static dg;
    private static df;
    private static de;
    private static qd;
    private static ql;
    private static kh;
    private static a5;
    private static qc;
    private static qm;
    private static qk;
    private static qj;
    private static qh;
    private static qi;
    private static q0;
    private static q1;
    private static q2;
    private static dl;
    private static dp;
    private static dn;
    private static dm;
    private static qz;
    private static q7;
    private static kj;
    private static a7;
    private static qy;
    private static q8;
    private static q6;
    private static q5;
    private static q3;
    private static q4;
    private static qp;
    private static qq;
    private static qr;
    private static dh;
    private static dk;
    private static dj;
    private static di;
    private static qo;
    private static qw;
    private static ki;
    private static a6;
    private static qn;
    private static qx;
    private static qv;
    private static qu;
    private static qs;
    private static qt;
    private static p3;
    private static p4;
    private static p5;
    private static c9;
    private static dc;
    private static db;
    private static da;
    private static p2;
    private static qa;
    private static kg;
    private static a4;
    private static p1;
    private static qb;
    private static p9;
    private static p8;
    private static p6;
    private static p7;
    private static o2;
    private static oq;
    private static nh;
    private static l;
    private static ot;
    private static ou;
    private static ov;
    private static ct;
    private static cw;
    private static cv;
    private static cu;
    private static os;
    private static o0;
    private static kc;
    private static a0;
    private static or;
    private static o1;
    private static oz;
    private static oy;
    private static ow;
    private static ox;
    private static nv;
    private static nw;
    private static nx;
    private static ch;
    private static ck;
    private static cj;
    private static ci;
    private static nu;
    private static n2;
    private static j9;
    private static ax;
    private static nt;
    private static n3;
    private static n1;
    private static n0;
    private static ny;
    private static nz;
    private static oh;
    private static oi;
    private static oj;
    private static cp;
    private static cs;
    private static cr;
    private static cq;
    private static og;
    private static oo;
    private static kb;
    private static az;
    private static of;
    private static op;
    private static on;
    private static om;
    private static ok;
    private static ol;
    private static n6;
    private static n7;
    private static n8;
    private static cl;
    private static co;
    private static cn;
    private static cm;
    private static n5;
    private static od;
    private static ka;
    private static ay;
    private static n4;
    private static oe;
    private static oc;
    private static ob;
    private static n9;
    private static oa;
    private static nk;
    private static nl;
    private static nm;
    private static cd;
    private static cg;
    private static cf;
    private static ce;
    private static nj;
    private static nr;
    private static j8;
    private static aw;
    private static ni;
    private static ns;
    private static nq;
    private static np;
    private static nn;
    private static no;
    private static c;
    private r9;
    private rx;
    private ng;
    private m;
    private r0;
    private r1;
    private r2;
    private dy;
    private d1;
    private d0;
    private dz;
    private rz;
    private r7;
    private km;
    private ba;
    private ry;
    private r8;
    private r6;
    private r5;
    private r3;
    private r4;
    private pg;
    private ph;
    private pi;
    private c1;
    private c4;
    private c3;
    private c2;
    private pf;
    private pn;
    private ke;
    private a2;
    private pe;
    private po;
    private pm;
    private pl;
    private pj;
    private pk;
    private ro;
    private rp;
    private rq;
    private du;
    private dx;
    private dw;
    private dv;
    private rn;
    private rv;
    private kl;
    private a9;
    private rm;
    private rw;
    private ru;
    private rt;
    private rr;
    private rs;
    private pr;
    private ps;
    private pt;
    private c5;
    private c8;
    private c7;
    private c6;
    private pq;
    private py;
    private kf;
    private a3;
    private pp;
    private pz;
    private px;
    private pw;
    private pu;
    private pv;
    private o5;
    private o6;
    private o7;
    private cx;
    private c0;
    private cz;
    private cy;
    private o4;
    private pc;
    private kd;
    private a1;
    private o3;
    private pd;
    private pb;
    private pa;
    private o8;
    private o9;
    private jx;
    private r;
    s: ButtonDisplayStyle;
    private f;
    h: ControlDisplayDensity;
    private b;
    d: BaseControlTheme;
    private e;
    g: ControlDisplayDensity;
    private ku;
    m2: Brush;
    private k5;
    nd: Brush;
    private k2;
    na: Brush;
    private ks;
    m0: Brush;
    private bj;
    cc: number;
    private bh;
    ca: number;
    private bi;
    cb: number;
    private k3;
    nb: Brush;
    private jy;
    j5: CornerRadius;
    private kt;
    m1: Brush;
    private kv;
    m3: Brush;
    private kw;
    m4: Brush;
    private kx;
    m5: Brush;
    private bg;
    b9: number;
    private i;
    k: ElevationMode;
    private k4;
    nc: Brush;
    private k1;
    m9: Brush;
    private ky;
    m6: Brush;
    private kz;
    m7: Brush;
    private k0;
    m8: Brush;
    private an;
    au: number;
    private mn;
    tp: Brush;
    private mp;
    tr: Brush;
    private mq;
    ts: Brush;
    private mr;
    tt: Brush;
    private b3;
    el: number;
    private mu;
    tw: Brush;
    private mo;
    tq: Brush;
    private b6;
    eo: number;
    private b5;
    en: number;
    private b4;
    em: number;
    private at;
    bf: number;
    private j4;
    kr: CornerRadius;
    private mw;
    ty: Brush;
    private ll;
    so: Brush;
    private ln;
    sq: Brush;
    private lo;
    sr: Brush;
    private lp;
    ss: Brush;
    private bp;
    d7: number;
    private ls;
    sv: Brush;
    private lm;
    sp: Brush;
    private bs;
    ea: number;
    private br;
    d9: number;
    private bq;
    d8: number;
    private lu;
    sx: Brush;
    private lv;
    sy: Brush;
    private lt;
    sw: Brush;
    private lq;
    st: Brush;
    private lr;
    su: Brush;
    private aq;
    bc: number;
    private j1;
    ko: CornerRadius;
    private k6;
    ne: Brush;
    private k8;
    sa: Brush;
    private k9;
    sb: Brush;
    private la;
    sc: Brush;
    private bk;
    d2: number;
    private j;
    o: ElevationMode;
    private ly;
    s1: Brush;
    private k7;
    nf: Brush;
    private b7;
    ep: number;
    private bu;
    ec: number;
    private bt;
    eb: number;
    private u;
    v: FontInfo;
    private mz;
    t1: Brush;
    private l0;
    s2: Brush;
    private my;
    t0: Brush;
    private mx;
    tz: Brush;
    private mv;
    tx: Brush;
    private ms;
    tu: Brush;
    private mt;
    tv: Brush;
    private lw;
    sz: Brush;
    private lx;
    s0: Brush;
    private ao;
    av: number;
    private jz;
    j7: CornerRadius;
    private mc;
    te: Brush;
    private me;
    tg: Brush;
    private mf;
    th: Brush;
    private mg;
    ti: Brush;
    private bz;
    eh: number;
    private mj;
    tl: Brush;
    private md;
    tf: Brush;
    private b2;
    ek: number;
    private b1;
    ej: number;
    private b0;
    ei: number;
    private as;
    be: number;
    private j3;
    kq: CornerRadius;
    private ml;
    tn: Brush;
    private mm;
    to: Brush;
    private mk;
    tm: Brush;
    private mh;
    tj: Brush;
    private mi;
    tk: Brush;
    private lb;
    sd: Brush;
    private ld;
    sf: Brush;
    private le;
    sg: Brush;
    private lf;
    sh: Brush;
    private bl;
    d3: number;
    private lz;
    sk: Brush;
    private lc;
    se: Brush;
    private bo;
    d6: number;
    private bn;
    d5: number;
    private bm;
    d4: number;
    private ap;
    bb: number;
    private j0;
    kn: CornerRadius;
    private lj;
    sm: Brush;
    private lk;
    sn: Brush;
    private li;
    sl: Brush;
    private lg;
    si: Brush;
    private lh;
    sj: Brush;
    private l1;
    s3: Brush;
    private l3;
    s5: Brush;
    private l4;
    s6: Brush;
    private l5;
    s7: Brush;
    private bv;
    ed: number;
    private l8;
    ta: Brush;
    private l2;
    s4: Brush;
    private by;
    eg: number;
    private bx;
    ef: number;
    private bw;
    ee: number;
    private ar;
    bd: number;
    private j2;
    kp: CornerRadius;
    private ma;
    tc: Brush;
    private mb;
    td: Brush;
    private l9;
    tb: Brush;
    private l6;
    s8: Brush;
    private l7;
    s9: Brush;
    private static es;
    private e2;
    h3: string;
    private static er;
    private e1;
    h1: string;
    private ey;
    f7: string;
    private ez;
    ha: string;
    private e0;
    hc: string;
    private ew;
    fr: string;
    private et;
    ev: any;
    private e3;
    h9: string;
    private b8;
    private z;
    readonly ah: boolean;
    eq: number;
    private ab;
    focused: boolean;
    private ac;
    ak: boolean;
    private ex;
    ft: string;
    private x;
    af: boolean;
    private w;
    ae: boolean;
    private ad;
    al: boolean;
    private aa;
    disabled: boolean;
    private y;
    ag: boolean;
    js(): void;
    private readonly a;
    private jj;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    appendButtonContent(a: any): void;
    protected am(): boolean;
    eu(): any;
    gb(): string;
    p(): ButtonVisualModelExport;
    provideContainer(a: DomRenderer): void;
    clicked: (sender: any, args: ButtonClickEventArgs) => void;
}
