import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
/**
 * @hidden
 */
export declare class CalendarView extends Base {
    static $t: Type;
    private g;
    private i;
    private j;
    private c;
    private b;
    private d;
    private e;
    private h;
    private l;
    constructor();
    a: Calendar;
    w(): void;
    f: DomRenderer;
    v(a: DomRenderer): void;
    n(): void;
    af(): void;
    ag(): void;
    ae(): void;
    ad(): void;
    aa(): void;
    ac(): void;
    ah(): void;
    z(): void;
    ab(a: DomWrapper): void;
    p(): void;
    private y;
    private t;
    private m;
    private k;
    private x;
    private s;
    private r;
    private ak;
    private o;
    private q;
    private ai;
    private aj;
    u(): void;
}
/**
 * @hidden
 */
export declare class Calendar extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private h;
    private static readonly z;
    private static readonly aa;
    u: Date;
    t: Date;
    private s;
    private o;
    private p;
    private n;
    private q;
    private r;
    private m;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    close: (sender: any) => void;
    a0(): void;
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    a2(a: Date): void;
    aw(a: string, b: string, c: string): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private x;
    v: Date;
    private c;
    d: ControlDisplayDensity;
    private a;
    b: BaseControlTheme;
    private bm;
    bs: Brush;
    private bo;
    bu: Brush;
    private bk;
    bq: Brush;
    private bn;
    bt: Brush;
    private bl;
    br: Brush;
    private bj;
    bp: Brush;
    private k;
    l: FontInfo;
    protected a1(a: string, b: any, c: any): void;
    protected a3(a: string, b: any, c: any): void;
    private bi;
    ay(): void;
    private ba;
    private a8;
    private aq;
    av(): void;
    private a5;
    ar(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    at(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    au(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    private as;
    bc(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    a9(a: DomWrapper): void;
    bh(a: DomWrapper): void;
    be(a: DomRenderer, b: DomWrapper): void;
    bb(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    bd(a: List$1<DomWrapper>): void;
    bg(a: List$1<DomWrapper>): void;
    bf(a: List$1<DomWrapper>, b: number, c?: boolean): void;
    private g;
    private f;
    an(a: number): void;
    ao(a: number): void;
    ap(a: number): void;
    a7(a: List$1<DomWrapper>, b: number): void;
    a6(): void;
    y(): any;
    af(): string;
    e(): CalendarVisualModelExport;
}
