import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
/**
 * @hidden
 */
export declare class DatePickerView extends Base {
    static $t: Type;
    constructor();
    a: DatePicker;
    o(): void;
    c: DomRenderer;
    private f;
    private d;
    private e;
    n(a: DomRenderer): void;
    private i;
    q(): void;
    private j;
    private h;
    private l;
    r(): Rect;
    private g;
    private k;
    private b;
    p(a: DomWrapper): void;
    m(): void;
}
/**
 * @hidden
 */
export declare class DatePicker extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private g;
    private static readonly aa;
    private static readonly x;
    private static readonly w;
    private m;
    private k;
    private j;
    private h;
    private i;
    private f;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    aq(a: Date): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private t;
    r: Date;
    private c;
    d: ControlDisplayDensity;
    private a;
    b: BaseControlTheme;
    private n;
    o: FontInfo;
    private p;
    q: boolean;
    protected ap(a: string, b: any, c: any): void;
    protected as(a: string, b: any, c: any): void;
    private aw;
    ak(a: DomRenderer, b: DomWrapper, c: DomWrapper, d: DomWrapper): void;
    ai(): void;
    private af;
    al(a: DomRenderer, b: DomWrapper): void;
    private ah;
    private ag;
    an(): void;
    ar(): void;
    aj(): void;
    private av;
    private au;
    u(): any;
    ab(): string;
    e(): DatePickerVisualModelExport;
}
