/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let CalendarVisualModelExport = /*@__PURE__*/ (() => {
    class CalendarVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.h = 0;
            this.g = 0;
            this.d = null;
            this.f = null;
            this.b = null;
            this.e = null;
            this.c = null;
            this.a = null;
            this.n = null;
            this.o = null;
            this.p = null;
            this.j = 0;
            this.l = null;
            this.m = null;
            this.i = null;
        }
        k() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("Density : " + enumGetBox(ControlDisplayDensity_$type, this.h) + ", ");
            a.l("BaseTheme : " + enumGetBox(BaseControlTheme_$type, this.g) + ", ");
            a.l("SelectedDateBackgroundColor : " + this.d.serialize() + ", ");
            a.l("SelectedFocusDateBackgroundColor : " + this.f.serialize() + ", ");
            a.l("FocusDateBackgroundColor : " + this.b.serialize() + ", ");
            a.l("SelectedDateTextColor : " + this.e.serialize() + ", ");
            a.l("FocusDateTextColor : " + this.c.serialize() + ", ");
            a.l("CurrentDateTextColor : " + this.a.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.n)) {
                a.l("textStyleFontStyle : \"" + this.n + "\", ");
            }
            if (!stringIsNullOrEmpty(this.o)) {
                a.l("textStyleFontVariant : \"" + this.o + "\", ");
            }
            if (!stringIsNullOrEmpty(this.p)) {
                a.l("textStyleFontWeight : \"" + this.p + "\", ");
            }
            if (!stringIsNullOrEmpty(this.l)) {
                a.l("textStyleFontFamily : \"" + this.l + "\", ");
            }
            if (!stringIsNullOrEmpty(this.m)) {
                a.l("textStyleFontStretch : \"" + this.m + "\", ");
            }
            if (!isNaN_(this.j)) {
                a.l("textStyleFontSize : " + this.j + ", ");
            }
            for (let b = 0; b < this.i.count; b++) {
                let c = this.i._inner[b].ah.charAt(0).toString().toLowerCase() + this.i._inner[b].ah.substr(1);
                a.l(c + ": " + this.i._inner[b].ai() + ", ");
            }
            a.l("}");
            return a.toString();
        }
    }
    CalendarVisualModelExport.$t = /*@__PURE__*/ markType(CalendarVisualModelExport, 'CalendarVisualModelExport');
    return CalendarVisualModelExport;
})();
//# sourceMappingURL=CalendarVisualModelExport.js.map
