/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { InputShiftType_$type } from "./InputShiftType";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let InputVisualModelExport = /*@__PURE__*/ (() => {
    class InputVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.d = 0;
            this.c = 0;
            this.j = null;
            this.m = null;
            this.f = false;
            this.b = null;
            this.a = null;
            this.q = null;
            this.r = null;
            this.s = null;
            this.h = 0;
            this.o = null;
            this.p = null;
            this.i = null;
            this.l = null;
            this.g = false;
            this.t = null;
            this.k = null;
        }
        n() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("shiftType : " + enumGetBox(InputShiftType_$type, this.e) + ", ");
            a.l("density : " + enumGetBox(ControlDisplayDensity_$type, this.d) + ", ");
            a.l("actualDensity : " + enumGetBox(ControlDisplayDensity_$type, this.c) + ", ");
            a.l("mask : " + this.j + ", ");
            a.l("promptChar : " + this.m + ", ");
            a.l("includeLiterals : " + this.f + ", ");
            a.l("actualTextColor : " + this.b.serialize() + ", ");
            a.l("actualHoverTextColor : " + this.a.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.q)) {
                a.l("textStyleFontStyle : \"" + this.q + "\", ");
            }
            if (!stringIsNullOrEmpty(this.r)) {
                a.l("textStyleFontVariant : \"" + this.r + "\", ");
            }
            if (!stringIsNullOrEmpty(this.s)) {
                a.l("textStyleFontWeight : \"" + this.s + "\", ");
            }
            if (!stringIsNullOrEmpty(this.o)) {
                a.l("textStyleFontFamily : \"" + this.o + "\", ");
            }
            if (!stringIsNullOrEmpty(this.p)) {
                a.l("textStyleFontStretch : \"" + this.p + "\", ");
            }
            if (!isNaN_(this.h)) {
                a.l("textStyleFontSize : " + this.h + ", ");
            }
            a.l("inputType : " + this.i + ", ");
            a.l("placeholder : " + this.l + ", ");
            a.l("isHover : " + this.g + ", ");
            a.l("value : " + this.t + ", ");
            a.l("name : " + this.k + ", ");
            a.l("}");
            return a.toString();
        }
    }
    InputVisualModelExport.$t = /*@__PURE__*/ markType(InputVisualModelExport, 'InputVisualModelExport');
    return InputVisualModelExport;
})();
//# sourceMappingURL=InputVisualModelExport.js.map
