/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, markType } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { LabelShiftType_$type } from "./LabelShiftType";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let LabelVisualModelExport = /*@__PURE__*/ (() => {
    class LabelVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.g = 0;
            this.f = 0;
            this.d = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.x = null;
            this.y = null;
            this.z = null;
            this.n = 0;
            this.v = null;
            this.w = null;
            this.h = 0;
            this.l = false;
            this.j = false;
            this.p = null;
            this.q = null;
            this.r = null;
            this.o = null;
            this.u = null;
            this.k = false;
            this.m = false;
            this.i = false;
            this.s = null;
        }
        t() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("baseTheme : " + enumGetBox(BaseControlTheme_$type, this.e) + ", ");
            a.l("density : " + enumGetBox(ControlDisplayDensity_$type, this.g) + ", ");
            a.l("actualDensity : " + enumGetBox(ControlDisplayDensity_$type, this.f) + ", ");
            a.l("actualTextColor : " + this.d.serialize() + ", ");
            a.l("actualHighlightTextColor : " + this.a.serialize() + ", ");
            a.l("actualHoverHighlightTextColor : " + this.b.serialize() + ", ");
            a.l("actualHoverTextColor : " + this.c.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.x)) {
                a.l("textStyleFontStyle : \"" + this.x + "\", ");
            }
            if (!stringIsNullOrEmpty(this.y)) {
                a.l("textStyleFontVariant : \"" + this.y + "\", ");
            }
            if (!stringIsNullOrEmpty(this.z)) {
                a.l("textStyleFontWeight : \"" + this.z + "\", ");
            }
            if (!stringIsNullOrEmpty(this.v)) {
                a.l("textStyleFontFamily : \"" + this.v + "\", ");
            }
            if (!stringIsNullOrEmpty(this.w)) {
                a.l("textStyleFontStretch : \"" + this.w + "\", ");
            }
            if (!isNaN_(this.n)) {
                a.l("textStyleFontSize : " + this.n + ", ");
            }
            a.l("shiftType : " + enumGetBox(LabelShiftType_$type, this.h) + ", ");
            a.l("isShifted : " + this.l + ", ");
            a.l("isHighlighted : " + this.j + ", ");
            a.l("display : " + this.p + ", ");
            a.l("flexDirection : " + this.q + ", ");
            a.l("flexGrow : " + this.r + ", ");
            a.l("alignItems : " + this.o + ", ");
            a.l("text : " + this.u + ", ");
            a.l("isHover : " + this.k + ", ");
            a.l("value : " + this.m + ", ");
            a.l("isDisabled : " + this.i + ", ");
            a.l("name : " + this.s + ", ");
            a.l("}");
            return a.toString();
        }
    }
    LabelVisualModelExport.$t = /*@__PURE__*/ markType(LabelVisualModelExport, 'LabelVisualModelExport');
    return LabelVisualModelExport;
})();
//# sourceMappingURL=LabelVisualModelExport.js.map
