/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, toNullable, Date_$type, enumGetBox } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { DayInfo } from "./DayInfo";
import { Button } from "./Button";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { Icon } from "./Icon";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { nullableNotEquals, unwrapNullable } from "igniteui-react-core";
import { dateNow, dateAddYears, dateFromValues, dateGetMonth, dateAddDays, dateAddMonths } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var CalendarView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(CalendarView, _super);
    function CalendarView() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.i = null;
        _this.j = null;
        _this.c = new List$1(DomWrapper_$type, 0);
        _this.b = new List$1(DomWrapper_$type, 0);
        _this.d = new List$1(DomWrapper_$type, 0);
        _this.e = new List$1(DomWrapper_$type, 0);
        _this.h = null;
        _this.l = null;
        _this.a = null;
        _this.f = null;
        _this.l = "day";
        _this.h = null;
        return _this;
    }
    CalendarView.prototype.w = function () {
    };
    CalendarView.prototype.v = function (a) {
        if (a == null) {
            this.f = null;
            return;
        }
        this.f = a;
        this.f.rootWrapper.setStyleProperty("background-color", "rgb(255, 255, 255)");
        var b = Math.round(a.rootWrapper.width());
        var c = Math.round(a.rootWrapper.height());
        this.n();
        this.af();
        this.ag();
        this.ae();
        var d = this.f.rootWrapper;
        d.listen("keydown", runOn(this, this.m));
    };
    CalendarView.prototype.n = function () {
        if (this.f != null) {
            this.g = this.f.createElement("div");
            this.g.setStyleProperty("height", "100%");
            this.f.append(this.g);
            for (var a = 0; a < 42; a++) {
                var b = this.f.createElement("div");
                this.b.add(b);
            }
            this.a.ar(this.f, this.g, this.b);
            this.i = this.f.createElement("div");
            this.i.setStyleProperty("height", "100%");
            this.f.append(this.i);
            for (var c = 0; c < 12; c++) {
                var d = this.f.createElement("div");
                this.d.add(d);
            }
            this.a.at(this.f, this.i, this.d);
            for (var e = 0; e < 12; e++) {
                var f = this.i.getChildAt(e);
                f.listen("click", runOn(this, this.q));
            }
            this.i.hide();
            this.j = this.f.createElement("div");
            this.j.setStyleProperty("height", "100%");
            this.f.append(this.j);
            for (var g = 0; g < 7; g++) {
                var h = this.f.createElement("div");
                this.e.add(h);
            }
            this.a.au(this.f, this.j, this.e);
            for (var i = 0; i < 7; i++) {
                var j = this.j.getChildAt(i);
                j.listen("click", runOn(this, this.ai));
            }
            this.j.listen("wheel", runOn(this, this.aj));
            this.j.hide();
        }
    };
    CalendarView.prototype.af = function () {
        if (this.f != null) {
            var a = this.g.getChildAt(0);
            for (var b = 0; b < 4; b++) {
                var c = this.f.createElement("div");
                this.c.add(c);
            }
            this.a.bc(this.f, a, this.c);
            var d = a.getChildAt(0);
            var e = a.getChildAt(3);
            d.listen("click", runOn(this, this.x));
            e.listen("click", runOn(this, this.s));
            var f = a.getChildAt(1);
            var g = a.getChildAt(2);
            f.listen("click", runOn(this, this.r));
            g.listen("click", runOn(this, this.ak));
        }
    };
    CalendarView.prototype.ag = function () {
        if (this.f != null) {
            var a = this.g.getChildAt(1);
            this.a.be(this.f, a);
        }
    };
    CalendarView.prototype.ae = function () {
        if (this.f != null) {
            this.a.bb(this.f, this.g, this.b);
            for (var a = 2; a < 8; a++) {
                var b = this.g.getChildAt(a);
                for (var c = 0; c < 7; c++) {
                    var d = b.getChildAt(c);
                    d.listen("click", runOn(this, this.o));
                }
            }
        }
    };
    CalendarView.prototype.ad = function () {
        if (this.f != null) {
            this.a.a9(this.c._inner[1]);
            this.a.bh(this.c._inner[2]);
        }
    };
    CalendarView.prototype.aa = function () {
        if (this.f != null) {
            this.a.bb(this.f, this.g, this.b);
        }
    };
    CalendarView.prototype.ac = function () {
        if (this.d.count != 0) {
            this.a.bd(this.d);
        }
    };
    CalendarView.prototype.ah = function () {
        if (this.e.count != 0) {
            this.a.bg(this.e);
        }
    };
    CalendarView.prototype.z = function () {
        this.aa();
        this.ad();
        this.l = "day";
        this.g.show();
        this.i.hide();
        this.j.hide();
        this.p();
    };
    CalendarView.prototype.ab = function (a) {
        this.h = a;
    };
    CalendarView.prototype.p = function () {
        if (this.h != null) {
            this.h.parent().parent().focus(false);
        }
    };
    CalendarView.prototype.y = function () {
        this.a.an(-1);
        this.aa();
        this.ad();
    };
    CalendarView.prototype.t = function () {
        this.a.an(1);
        this.aa();
        this.ad();
    };
    CalendarView.prototype.m = function (a) {
        var b = a.which;
        if (this.l == "day") {
            var c = this.h.getAttribute("data-section").toString();
            var d = parseInt(this.h.getAttribute("data-index").toString());
            if (c == "header") {
                if (b == 37) {
                    if (d > 0) {
                        var e = this.c._inner[d - 1];
                        this.ab(e);
                        this.p();
                    }
                }
                else if (b == 39) {
                    if (d < 3) {
                        var f = this.c._inner[d + 1];
                        this.ab(f);
                        this.p();
                    }
                }
                else if (b == 9) {
                    a.preventDefault();
                    this.aa();
                    this.p();
                }
            }
            else if (c == "days") {
                var g = this.h.getAttribute("data-day").toString();
                var h = this.h.getAttribute("data-month").toString();
                if (b == 37) {
                    if (d == 0) {
                        this.y();
                    }
                    else {
                        var i = this.b._inner[d - 1];
                        var j = i.getAttribute("data-day").toString();
                        var k = i.getAttribute("data-month").toString();
                        if (h == k) {
                            this.ab(i);
                            this.p();
                        }
                        else {
                            this.y();
                            var l = this.k(j, k);
                            this.ab(l);
                            this.p();
                        }
                    }
                }
                else if (b == 39) {
                    if (d == 41) {
                        this.t();
                    }
                    else {
                        var m = this.b._inner[d + 1];
                        var n = m.getAttribute("data-day").toString();
                        var o = m.getAttribute("data-month").toString();
                        if (h == o) {
                            this.ab(m);
                            this.p();
                        }
                        else {
                            this.t();
                            var p = this.k(n, o);
                            this.ab(p);
                            this.p();
                        }
                    }
                }
                else if (b == 40) {
                    if (d >= 35) {
                        this.t();
                        var q = this.k(g, h);
                        var r = parseInt(q.getAttribute("data-index").toString());
                        var s = this.b._inner[r + 7];
                        var t = s.getAttribute("data-day").toString();
                        var u = s.getAttribute("data-month").toString();
                        var v = this.k(t, u);
                        this.ab(v);
                        this.p();
                    }
                    else {
                        var w = this.b._inner[d + 7];
                        var x = w.getAttribute("data-day").toString();
                        var y = w.getAttribute("data-month").toString();
                        if (h == y) {
                            this.ab(w);
                            this.p();
                        }
                        else {
                            this.t();
                            var z = this.k(x, y);
                            this.ab(z);
                            this.p();
                        }
                    }
                }
                else if (b == 38) {
                    if (d <= 6) {
                        this.y();
                        var aa = this.k(g, h);
                        var ab = parseInt(aa.getAttribute("data-index").toString());
                        var ac = this.b._inner[ab - 7];
                        var ad = ac.getAttribute("data-day").toString();
                        var ae = ac.getAttribute("data-month").toString();
                        var af = this.k(ad, ae);
                        this.ab(af);
                        this.p();
                    }
                    else {
                        var ag = this.b._inner[d - 7];
                        var ah = ag.getAttribute("data-day").toString();
                        var ai = ag.getAttribute("data-month").toString();
                        if (h == ai) {
                            this.ab(ag);
                            this.p();
                        }
                        else {
                            this.y();
                            var aj = this.k(ah, ai);
                            this.ab(aj);
                            this.p();
                        }
                    }
                }
                else if (b == 34) {
                    this.t();
                }
                else if (b == 33) {
                    this.y();
                }
                else if (b == 9) {
                    a.preventDefault();
                    var ak = this.c._inner[1];
                    this.ab(ak);
                    this.p();
                }
            }
        }
        else if (this.l == "month") {
            var al = parseInt(this.h.getAttribute("data-index").toString());
            if (b == 37) {
                if (al == 0) {
                    var am = this.d._inner[11];
                    this.ab(am);
                    this.p();
                }
                else {
                    var an = this.d._inner[al - 1];
                    this.ab(an);
                    this.p();
                }
            }
            else if (b == 39) {
                if (al == 11) {
                    var ao = this.d._inner[0];
                    this.ab(ao);
                    this.p();
                }
                else {
                    var ap = this.d._inner[al + 1];
                    this.ab(ap);
                    this.p();
                }
            }
            else if (b == 40) {
                if (al >= 9) {
                    var aq = this.d._inner[al - 9];
                    this.ab(aq);
                    this.p();
                }
                else {
                    var ar = this.d._inner[al + 3];
                    this.ab(ar);
                    this.p();
                }
            }
            else if (b == 38) {
                if (al <= 2) {
                    var as = this.d._inner[al + 9];
                    this.ab(as);
                    this.p();
                }
                else {
                    var at = this.d._inner[al - 3];
                    this.ab(at);
                    this.p();
                }
            }
        }
        else if (this.l == "year") {
            var au = parseInt(this.h.getAttribute("data-index").toString());
            if (b == 40) {
                this.a.a7(this.e, 1);
            }
            else if (b == 38) {
                this.a.a7(this.e, -1);
            }
        }
        if (b == 27) {
            this.z();
            this.a.a0();
        }
    };
    CalendarView.prototype.k = function (a, b) {
        var c = null;
        for (var d = 0; d < 42; d++) {
            var e = this.b._inner[d];
            var f = e.getAttribute("data-day").toString();
            var g = e.getAttribute("data-month").toString();
            if (b == g && a == f) {
                c = e;
                break;
            }
        }
        return c;
    };
    CalendarView.prototype.x = function (a) {
        this.y();
    };
    CalendarView.prototype.s = function (a) {
        this.t();
    };
    CalendarView.prototype.r = function (a) {
        this.g.hide();
        this.i.show();
        this.i.setStyleProperty("display", "flex");
        this.j.hide();
        this.l = "month";
        this.ac();
        this.p();
    };
    CalendarView.prototype.ak = function (a) {
        this.g.hide();
        this.i.hide();
        this.j.show();
        this.l = "year";
        this.ah();
        this.p();
    };
    CalendarView.prototype.o = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.innerText;
        var c = a.lastChild.lastChild.lastChild;
        var d = c.getAttribute("data-month").toString();
        var e = c.getAttribute("data-year").toString();
        if (b != "") {
            this.a.aw(b, d, e);
        }
    };
    CalendarView.prototype.q = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.getAttribute("data-month").toString();
        if (b != "") {
            this.a.ao(parseInt(b));
            this.z();
        }
    };
    CalendarView.prototype.ai = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.innerText;
        if (b != "") {
            this.a.ap(parseInt(b));
            this.z();
        }
    };
    CalendarView.prototype.aj = function (e_) {
        var a = (e_.originalEvent.deltaY);
        this.a.a7(this.e, a);
    };
    CalendarView.prototype.u = function () {
    };
    CalendarView.$t = markType(CalendarView, 'CalendarView');
    return CalendarView;
}(Base));
export { CalendarView };
/**
 * @hidden
 */
var Calendar = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(Calendar, _super);
    function Calendar() {
        var _this = _super.call(this) || this;
        _this.h = null;
        _this.u = dateNow();
        _this.t = dateNow();
        _this.s = new Date();
        _this.o = null;
        _this.p = null;
        _this.n = null;
        _this.q = null;
        _this.r = null;
        _this.m = null;
        _this.propertyChanged = null;
        _this.close = null;
        _this.valueChanged = null;
        _this.x = toNullable(Date_$type, null);
        _this.c = 2;
        _this.a = 1;
        _this.bm = BrushUtil.g(255, 33, 150, 243);
        _this.bo = BrushUtil.g(255, 21, 112, 184);
        _this.bk = BrushUtil.g(76, 33, 150, 243);
        _this.bn = BrushUtil.g(255, 255, 255, 255);
        _this.bl = BrushUtil.g(255, 24, 29, 31);
        _this.bj = BrushUtil.g(255, 33, 150, 243);
        _this.k = null;
        _this.s = dateAddYears(_this.s, -200);
        _this.o = new ObservableCollection$1(DayInfo.$, 0);
        _this.p = new ObservableCollection$1(Button.$, 0);
        _this.n = new ObservableCollection$1(Button.$, 0);
        _this.q = new ObservableCollection$1(Button.$, 0);
        _this.r = new ObservableCollection$1(Button.$, 0);
        var a = new CalendarView();
        a.a = _this;
        _this.h = a;
        _this.h.w();
        return _this;
    }
    Calendar.prototype.a0 = function () {
        if (this.close != null) {
            this.close(this);
        }
    };
    Calendar.prototype.a2 = function (a) {
        this.x = toNullable(Date_$type, a);
        if (this.valueChanged != null) {
            this.valueChanged(this, ((function () {
                var $ret = new ValueChangedEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
        this.u = this.x.value;
        this.a5();
    };
    Calendar.prototype.aw = function (a, b, c) {
        var d = dateFromValues(parseInt(c), parseInt(b), parseInt(a), 0, 0, 0, 0);
        this.a2(d);
    };
    Calendar.prototype.notifySizeChanged = function () {
        this.h.u();
    };
    Calendar.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Calendar.prototype.provideContainer = function (a) {
        this.h.v(a);
    };
    Object.defineProperty(Calendar.prototype, "v", {
        get: function () {
            return this.x.value;
        },
        set: function (a) {
            var b = this.x;
            this.x = toNullable(Date_$type, a);
            if (nullableNotEquals(b, this.x)) {
                this.a1("Value", unwrapNullable(b), unwrapNullable(this.x));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.a1("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.c));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.a1("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "bs", {
        get: function () {
            return this.bm;
        },
        set: function (a) {
            var b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.a1("SelectedDateBackgroundColor", b, this.bm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "bu", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            var b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.a1("SelectedFocusDateBackgroundColor", b, this.bo);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "bq", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            var b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.a1("FocusDateBackgroundColor", b, this.bk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "bt", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.a1("SelectedDateTextColor", b, this.bn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "br", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.a1("FocusDateTextColor", b, this.bl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "bp", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.a1("CurrentDateTextColor", b, this.bj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.a1("TextStyle", b, this.k);
            }
        },
        enumerable: true,
        configurable: true
    });
    Calendar.prototype.a1 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.a3(a, b, c);
    };
    Calendar.prototype.a3 = function (a, b, c) {
        switch (a) {
            case "Density":
                this.a8();
                break;
            case "BaseTheme":
                this.ba();
                break;
            case "Value":
                this.u = this.x.value;
                this.a5();
                break;
            case "SelectedDateBackgroundColor":
            case "SelectedDateTextColor":
            case "SelectedFocusDateBackgroundColor":
            case "FocusDateBackgroundColor":
            case "FocusDateTextColor":
            case "CurrentDateTextColor": break;
            case "TextStyle":
                this.bi();
                break;
        }
    };
    Calendar.prototype.bi = function () {
        for (var a = 0; a < this.p.count; a++) {
            if (this.k != null) {
                this.p._inner[a].v = this.k;
            }
        }
        for (var b = 0; b < this.n.count; b++) {
            if (this.k != null) {
                this.n._inner[b].v = this.k;
            }
        }
        for (var c = 0; c < this.q.count; c++) {
            if (this.k != null) {
                this.q._inner[c].v = this.k;
            }
        }
        for (var d = 0; d < this.r.count; d++) {
            if (this.k != null) {
                this.r._inner[d].v = this.k;
            }
        }
    };
    Calendar.prototype.ay = function () {
        this.h.p();
    };
    Calendar.prototype.ba = function () {
    };
    Calendar.prototype.a8 = function () {
    };
    Calendar.prototype.aq = function () {
    };
    Calendar.prototype.av = function () {
        this.x = toNullable(Date_$type, null);
        this.h.aa();
    };
    Calendar.prototype.a5 = function () {
        this.as();
        this.h.ad();
        this.h.ah();
        this.h.aa();
    };
    Calendar.prototype.ar = function (a, b, c) {
        var d = a.createElement("div");
        d.setStyleProperty("height", "14%");
        d.setStyleProperty("display", "flex");
        d.setStyleProperty("justify-content", "space-evenly");
        var e = a.createElement("div");
        var f = a.createElement("div");
        var g = a.createElement("div");
        var h = a.createElement("div");
        d.append(e);
        d.append(f);
        d.append(g);
        d.append(h);
        b.append(d);
        var i = 0;
        for (var j = 0; j < 7; j++) {
            var k = a.createElement("div");
            k.setStyleProperty("display", "flex");
            k.setStyleProperty("justify-content", "space-evenly");
            if (j == 0) {
                k.setStyleProperty("height", "8%");
                for (var l = 0; l < 7; l++) {
                    var m = a.createElement("div");
                    m.setStyleProperty("text-align", "center");
                    m.setStyleProperty("vertical-align", "middle");
                    m.setStyleProperty("width", "14%");
                    var n = a.createElement("span");
                    n.setStyleProperty("font", "16px \"Segoe UI\", Verdana");
                    n.setStyleProperty("color", "rgb(24, 29, 31)");
                    m.append(n);
                    k.append(m);
                }
            }
            else {
                k.setStyleProperty("height", "13%");
                for (var o = 0; o < 7; o++) {
                    var p = a.createElement("div");
                    var q = c._inner[i];
                    var r = this.g(a, p, q, 4);
                    this.n.add(r);
                    r.h9 = "btnDays" + o.toString();
                    p.setStyleProperty("width", "14%");
                    p.setStyleProperty("height", "100%");
                    k.append(p);
                    i++;
                }
            }
            b.append(k);
        }
        this.as();
    };
    Calendar.prototype.at = function (a, b, c) {
        b.setStyleProperty("display", "flex");
        b.setStyleProperty("flex-direction", "row");
        b.setStyleProperty("flex-wrap", "wrap");
        b.setStyleProperty("margin", "2px");
        for (var d = 0; d < 12; d++) {
            var e = a.createElement("div");
            e.setAttribute("data-month", (d + 1).toString());
            var f = c._inner[d];
            var g = this.g(a, e, f, 1);
            this.q.add(g);
            e.setStyleProperty("width", "33%");
            var h = e.getChildAt(0);
            h.setStyleProperty("width", "100%");
            var i = f.getChildAt(0);
            var j = "";
            var k = d + 1;
            switch (k) {
                case 1:
                    j = "Jan";
                    break;
                case 2:
                    j = "Feb";
                    break;
                case 3:
                    j = "Mar";
                    break;
                case 4:
                    j = "Apr";
                    break;
                case 5:
                    j = "May";
                    break;
                case 6:
                    j = "Jun";
                    break;
                case 7:
                    j = "Jul";
                    break;
                case 8:
                    j = "Aug";
                    break;
                case 9:
                    j = "Sep";
                    break;
                case 10:
                    j = "Oct";
                    break;
                case 11:
                    j = "Nov";
                    break;
                case 12:
                    j = "Dec";
                    break;
            }
            g.h9 = "btnMonth" + j;
            i.setText(j);
            if (nullableNotEquals(this.x, null) && dateGetMonth(this.x.value) == k) {
                g.sy = this.bj;
                g.su = this.bj;
                g.so = BrushUtil.g(0, 255, 255, 255);
                g.st = this.bk;
            }
            else {
                g.sy = BrushUtil.g(255, 24, 29, 31);
                g.su = this.bl;
                g.so = BrushUtil.g(0, 255, 255, 255);
                g.st = this.bk;
            }
            f.setAttribute("data-index", d.toString());
            f.append(i);
            b.append(e);
        }
    };
    Calendar.prototype.au = function (a, b, c) {
        var d = this.u.getFullYear() - 3;
        for (var e = 0; e < 7; e++) {
            var f = a.createElement("div");
            var g = c._inner[e];
            var h = this.g(a, f, g, 1);
            this.r.add(h);
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "14%");
            f.setStyleProperty("justify-content", "space-around");
            var i = f.getChildAt(0);
            i.setStyleProperty("width", "100%");
            var j = g.getChildAt(0);
            h.h9 = "btnYear" + e.toString();
            j.setText(d.toString());
            if (e == 3) {
                h.sy = this.bj;
                h.su = this.bj;
                h.st = BrushUtil.g(0, 255, 255, 255);
                h.sv = BrushUtil.g(0, 255, 255, 255);
                h.sp = BrushUtil.g(0, 255, 255, 255);
            }
            else {
                h.sy = BrushUtil.g(255, 24, 29, 31);
                h.su = this.bl;
                h.st = BrushUtil.g(0, 255, 255, 255);
                h.sv = BrushUtil.g(0, 255, 255, 255);
                h.sp = BrushUtil.g(0, 255, 255, 255);
            }
            d++;
            g.setAttribute("data-index", e.toString());
            g.append(j);
            b.append(f);
        }
    };
    Calendar.prototype.as = function () {
        this.o.clear();
        var a = dateAddDays(this.u, -(this.u.getDate() - 1));
        var b = a.getDay();
        a = dateAddDays(a, -b);
        while (this.o.count < 42) {
            var c = new DayInfo();
            c.b = a.getDate();
            c.c = dateGetMonth(a);
            c.d = a.getFullYear();
            c.a = a.getDay();
            this.o.add(c);
            a = dateAddDays(a, 1);
        }
    };
    Calendar.prototype.bc = function (a, b, c) {
        var d = b.getChildAt(0);
        var e = c._inner[0];
        var f = this.f(a, d, e, Calendar.z);
        f.td = BrushUtil.g(255, 24, 29, 31);
        f.s9 = this.bl;
        f.s3 = BrushUtil.g(0, 255, 255, 255);
        f.s8 = this.bk;
        f.h9 = "btnPrev";
        this.p.add(f);
        e.setAttribute("data-section", "header");
        e.setAttribute("data-index", "0");
        var g = b.getChildAt(1);
        var h = c._inner[1];
        var i = this.g(a, g, h, 1);
        i.sy = BrushUtil.g(255, 24, 29, 31);
        i.su = this.bl;
        i.so = BrushUtil.g(0, 255, 255, 255);
        i.st = this.bk;
        i.h9 = "btnMonth";
        this.p.add(i);
        h.setAttribute("data-section", "header");
        h.setAttribute("data-index", "1");
        this.a9(h);
        var j = b.getChildAt(2);
        var k = c._inner[2];
        var l = this.g(a, j, k, 1);
        l.sy = BrushUtil.g(255, 24, 29, 31);
        l.su = this.bl;
        l.so = BrushUtil.g(0, 255, 255, 255);
        l.st = this.bk;
        l.h9 = "btnYear";
        this.p.add(l);
        k.setAttribute("data-section", "header");
        k.setAttribute("data-index", "2");
        this.bh(k);
        var m = b.getChildAt(3);
        var n = c._inner[3];
        var o = this.f(a, m, n, Calendar.aa);
        o.td = BrushUtil.g(255, 24, 29, 31);
        o.s9 = this.bl;
        o.s3 = BrushUtil.g(0, 255, 255, 255);
        o.s8 = this.bk;
        o.h9 = "btnNext";
        this.p.add(o);
        n.setAttribute("data-section", "header");
        n.setAttribute("data-index", "3");
    };
    Calendar.prototype.a9 = function (a) {
        var b = a.getChildAt(0);
        var c = dateGetMonth(this.u);
        var d = "";
        switch (c) {
            case 1:
                d = "Jan";
                break;
            case 2:
                d = "Feb";
                break;
            case 3:
                d = "Mar";
                break;
            case 4:
                d = "Apr";
                break;
            case 5:
                d = "May";
                break;
            case 6:
                d = "Jun";
                break;
            case 7:
                d = "Jul";
                break;
            case 8:
                d = "Aug";
                break;
            case 9:
                d = "Sep";
                break;
            case 10:
                d = "Oct";
                break;
            case 11:
                d = "Nov";
                break;
            case 12:
                d = "Dec";
                break;
        }
        b.setText(d);
    };
    Calendar.prototype.bh = function (a) {
        var b = a.getChildAt(0);
        var c = this.u.getFullYear().toString();
        b.setText(c);
    };
    Calendar.prototype.be = function (a, b) {
        var c = b.getChildAt(0);
        var d = c.getChildAt(0);
        d.setText("S");
        c.append(d);
        var e = b.getChildAt(1);
        var f = e.getChildAt(0);
        f.setText("M");
        e.append(f);
        var g = b.getChildAt(2);
        var h = g.getChildAt(0);
        h.setText("T");
        g.append(h);
        var i = b.getChildAt(3);
        var j = i.getChildAt(0);
        j.setText("W");
        i.append(j);
        var k = b.getChildAt(4);
        var l = k.getChildAt(0);
        l.setText("T");
        k.append(l);
        var m = b.getChildAt(5);
        var n = m.getChildAt(0);
        n.setText("F");
        m.append(n);
        var o = b.getChildAt(6);
        var p = o.getChildAt(0);
        p.setText("S");
        o.append(p);
    };
    Calendar.prototype.bb = function (a, b, c) {
        var d = null;
        var e = null;
        var f = null;
        for (var g = 0; g < 42; g++) {
            var h = c._inner[g];
            var i = h.getChildAt(0);
            var j = this.o._inner[g];
            var k = this.n._inner[g];
            if (j != null) {
                h.setAttribute("data-section", "days");
                h.setAttribute("data-index", g.toString());
                h.setAttribute("data-day", j.b.toString());
                h.setAttribute("data-month", j.c.toString());
                h.setAttribute("data-year", j.d.toString());
                i.setText(j.b.toString());
                if (nullableNotEquals(this.x, null) && j.b == this.x.value.getDate() && j.c == dateGetMonth(this.x.value) && j.d == this.x.value.getFullYear()) {
                    k.td = this.bn;
                    k.s9 = this.bn;
                    k.s3 = this.bm;
                    k.s8 = this.bo;
                    d = h;
                }
                else if (j.b == this.s.getDate() && j.c == dateGetMonth(this.s) && j.d == this.s.getFullYear()) {
                    k.td = this.bl;
                    k.s9 = this.bl;
                    k.s3 = BrushUtil.g(0, 255, 255, 255);
                    k.s8 = this.bk;
                }
                else if (j.b == this.t.getDate() && j.c == dateGetMonth(this.t) && j.d == this.t.getFullYear()) {
                    k.td = this.bj;
                    k.s9 = this.bl;
                    k.s3 = BrushUtil.g(0, 255, 255, 255);
                    k.s8 = this.bk;
                    e = h;
                }
                else if (j.a != 0 && j.a != 6 && j.c == dateGetMonth(this.u)) {
                    k.td = BrushUtil.g(255, 24, 29, 31);
                    k.s9 = this.bl;
                    k.s3 = BrushUtil.g(0, 255, 255, 255);
                    k.s8 = this.bk;
                }
                else {
                    k.td = BrushUtil.g(255, 163, 172, 184);
                    k.s9 = this.bl;
                    k.s3 = BrushUtil.g(0, 255, 255, 255);
                    k.s8 = this.bk;
                }
                if (j.b == 1 && j.c == dateGetMonth(this.u)) {
                    f = h;
                }
            }
        }
        if (d != null && nullableNotEquals(this.x, null) && this.x.value.getFullYear() == this.u.getFullYear() && dateGetMonth(this.x.value) == dateGetMonth(this.u)) {
            this.h.ab(d);
        }
        else if (e != null && this.t.getFullYear() == this.u.getFullYear() && dateGetMonth(this.t) == dateGetMonth(this.u)) {
            this.h.ab(e);
        }
        else if (f != null) {
            this.h.ab(f);
        }
    };
    Calendar.prototype.bd = function (a) {
        var b = null;
        var c = null;
        for (var d = 0; d < 12; d++) {
            var e = a._inner[d];
            var f = e.getChildAt(0);
            var g = this.q._inner[d];
            if (nullableNotEquals(this.x, null) && dateGetMonth(this.x.value) == d + 1) {
                g.sy = this.bj;
                g.su = this.bj;
                g.so = BrushUtil.g(0, 255, 255, 255);
                g.st = this.bk;
                c = e;
            }
            else {
                g.sy = BrushUtil.g(255, 24, 29, 31);
                g.su = this.bl;
                g.so = BrushUtil.g(0, 255, 255, 255);
                g.st = this.bk;
            }
            if (dateGetMonth(this.t) == d + 1) {
                b = e;
            }
        }
        if (c != null) {
            this.h.ab(c);
        }
        else if (b != null) {
            this.h.ab(b);
        }
        else {
            this.h.ab(a._inner[0]);
        }
    };
    Calendar.prototype.bg = function (a) {
        this.bf(a, this.u.getFullYear(), true);
    };
    Calendar.prototype.bf = function (a, b, c) {
        if (c === void 0) {
            c = false;
        }
        var d = b - 3;
        for (var e = 0; e < 7; e++) {
            var f = a._inner[e];
            var g = f.getChildAt(0);
            g.setText(d.toString());
            if (d == b && c) {
                this.h.ab(f);
            }
            if (e == 3) {
            }
            else {
            }
            d++;
        }
    };
    Calendar.prototype.g = function (a, b, c, d) {
        var e = a.getSubRenderer(b);
        var f = new Button();
        f.provideContainer(e);
        f.d = this.b;
        f.h = this.d;
        f.s = d;
        if (this.k != null) {
            f.v = this.k;
        }
        var g = a.createElement("span");
        var h = new CornerRadius(0, 25);
        f.j7 = h;
        c.append(g);
        f.appendButtonContent(c);
        return f;
    };
    Calendar.prototype.f = function (a, b, c, d) {
        var e = a.getSubRenderer(b);
        var f = new Button();
        f.provideContainer(e);
        f.d = this.b;
        f.h = this.d;
        f.s = 4;
        var g = a.createElement("div");
        var h = a.getSubRenderer(g);
        var i = new Icon();
        i.provideContainer(h);
        i.svgPath = d;
        c.append(g);
        f.appendButtonContent(c);
        return f;
    };
    Calendar.prototype.an = function (a) {
        this.u = dateAddMonths(this.u, a);
        this.as();
    };
    Calendar.prototype.ao = function (a) {
        this.u = dateFromValues(this.u.getFullYear(), a, this.u.getDate(), 0, 0, 0, 0);
        this.as();
    };
    Calendar.prototype.ap = function (a) {
        this.u = dateFromValues(a, dateGetMonth(this.u), this.u.getDate(), 0, 0, 0, 0);
        this.as();
    };
    Calendar.prototype.a7 = function (a, b) {
        var c = parseInt(a._inner[3].getChildAt(0).getText());
        if (b < 0) {
            c--;
        }
        else {
            c++;
        }
        this.bf(a, c);
    };
    Calendar.prototype.a6 = function () {
        this.h.z();
    };
    Calendar.prototype.y = function () {
        return this.e();
    };
    Calendar.prototype.af = function () {
        var a = this.e();
        return a.k();
    };
    Calendar.prototype.e = function () {
        var a = new CalendarVisualModelExport();
        a.h = this.d;
        a.g = this.b;
        a.d = AppearanceHelper.a(this.bs);
        a.f = AppearanceHelper.a(this.bu);
        a.b = AppearanceHelper.a(this.bq);
        a.e = AppearanceHelper.a(this.bt);
        a.c = AppearanceHelper.a(this.br);
        a.a = AppearanceHelper.a(this.bp);
        a.i = new List$1(ButtonVisualModelExport.$, 0);
        for (var b = 0; b < this.p.count; b++) {
            if (this.p._inner[b].h9 == null) {
                this.p._inner[b].h9 = "header" + b.toString();
            }
            a.i.add1(this.p._inner[b].eu());
        }
        for (var c = 0; c < this.n.count; c++) {
            if (this.n._inner[c].h9 == null) {
                this.n._inner[c].h9 = "days" + c.toString();
            }
            a.i.add1(this.n._inner[c].eu());
        }
        for (var d = 0; d < this.q.count; d++) {
            if (this.q._inner[d].h9 == null) {
                this.q._inner[d].h9 = "months" + d.toString();
            }
            a.i.add1(this.q._inner[d].eu());
        }
        for (var e = 0; e < this.r.count; e++) {
            if (this.r._inner[e].h9 == null) {
                this.r._inner[e].h9 = "years" + e.toString();
            }
            a.i.add1(this.r._inner[e].eu());
        }
        if (this.l != null) {
            var f = this.l;
            if (this.h != null && f.n == null) {
                var g = this.h.f;
                var h = FontUtil.getFontInfoFromString(g, f.fontString);
                f.n = h.n;
                f.d = h.d;
                f.o = h.o;
                f.q = h.q;
                f.r = h.r;
                f.s = h.s;
            }
            if (f.n != null) {
                a.l = f.n;
            }
            if (!isNaN_(f.d)) {
                a.j = f.d;
            }
            if (f.s != null) {
                a.p = f.s;
            }
            if (f.q != null) {
                a.n = f.q;
            }
            if (f.o != null) {
                a.m = f.q;
            }
        }
        return a;
    };
    Calendar.$t = markType(Calendar, 'Calendar', Base.$, [INotifyPropertyChanged_$type]);
    Calendar.z = "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z";
    Calendar.aa = "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z";
    return Calendar;
}(Base));
export { Calendar };
//# sourceMappingURL=CalendarView_combined.js.map
